(* Released into the public domain April 1, 1995.  No warranties, use at *)
(* your own risk.  Copyright Jason Cory Wright 1995                      *)
{$M $6000, $0, $16000}
{$N+,E+}
PROGRAM DWORKLOG;

(*************************************************************************
 Copyright Cory Wright 1991, 1992.
 *************************************************************************
 The DoorWorks Project - Jan 20, 1991 - DWORKLOG to make log reports.
 *************************************************************************)
{v2.10 released 3/18/1991}
{v2.20beta work started 7/15/1992}
{v2.21beta work started 9/11/1993}

Uses Dos, Crt, KeyTTT5, FastTTT5, MiscTTT5, StrnTTT5, TRCSTD92;

CONST
           ver = '2.21';
         pname = 'DoorWorks Log Reporter';
copyright_date = '1990-1993.';
      ngtcnf = 'gt.cnf';
        nerr = 'dworklog.err';
        nlog = 'dworkdor.log';
         cbs = '.CBS';
        dnrw = $42;  {deny none, read/write mode}
     divider = '';
    divider2 = '';
    divider3 = '------------------------------------------------------------------------------';
        days : array[0..6] of string[3] = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
      months : array[1..12] of string[3] = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');


TYPE
  HueType  = Array[1..15] of String[7];
  elementarray = array[1..999] of longint;

     dwcnf = RECORD
        bbs : string[65];
     serial : integer;
        crc : string[11];
   sysfirst : string[31];
    syslast : string[31];
        dis : boolean;
        prn : boolean;
        bel : boolean;
        ala : boolean;
       lock : word;
         sl : integer;
    kickoff : integer;
  minexpire : integer;
      hayes : boolean;
    windows : boolean;
  gtversion : real;
  biosvideo : boolean;
   usercaps : boolean;
     editor : string[40];
 usenetwork : boolean;
    defline : string[80];
     filler : string[40];
  end; {dwcnf}


VAR
  cnf : dwcnf;
 fcnf : file of dwcnf;

showdate : string;
       c : word;

{ Calcuation vars }
  time_in_door : elementarray; {longint}
  times_opened : array[1..999] of word;
      doorname : array[1..999] of string[15];

{ Color variables }
    hue : huetype;
windowf : integer;
  chatf : integer;
  title : integer;
  high,lo : integer;
 status : integer;
  frame : integer;

{ Environmental variables }
    gtpath : string;
   trcpath : string;
    bbscbs : string;
  bullpath : string;

{ Date variables }
 sincedate : string[12];
 y, m, d, dow : word;
 day, year : string;


(****************************************************************************)
PROCEDURE Sort( var a : elementarray; n : integer );

var
  i,j,bottom,top,middle : integer;
  temp : longint;
  temp2 : string[15];
  temp3 : word;
  t1 : array[1..999] of longint;
  t2 : array[1..999] of string[15];
  t3 : array[1..999] of word;

begin
  for i := 2 to n do
  begin
    temp := a[i];
    temp2 := doorname[i];
    temp3 := times_opened[i];
    bottom := 1; top := i-1;
    while bottom <= top do
    begin
      middle := (bottom + top) div 2;
      if temp < a[middle] then
        top := middle - 1
      else
        bottom := middle + 1;
    end; {while}
    for j := i - 1 downto bottom do
    begin
      a[j+1] := a[j];
      doorname[j+1] := doorname[j];
      times_opened[j+1] := times_opened[j];
    end;

    a[bottom] := temp;
    doorname[bottom] := temp2;
    times_opened[bottom] := temp3;

  end; {for}

  j := 0;
  {Convert ascending to descending}
  for i := c downto 1 do
  begin
    inc(j);
    t1[j] := a[i];
    t2[j] := doorname[i];
    t3[j] := times_opened[i];
  end;

  for i := 1 to c do
  begin
    a[i] := t1[i];
    doorname[i] := t2[i];
    times_opened[i] := t3[i];
  end;

end; {Sort}
(****************************************************************************)
PROCEDURE Initialize;

var
  gtcnf  : text;
  ln     : string;
  choice : string;
  z : integer;

begin

  Randomize;

  GetDate( y, m, d, dow );

  str(d, day);
  str(y, year);
  showdate := days[dow] + ' ' + months[m] + ' ' + day + ', ' + year;

  gtpath := GetEnv('GTPATH');
  if gtpath = '' then
    begin
      writeln;
      writeln('GTPATH is not SET.  SET GTPATH=<gt directory> before continuing.');
      halt( 1 );
    end;

  if gtpath[length(gtpath)] <> '\' then
    gtpath := gtpath + '\';

  trcpath := gtpath + 'TRC\';

  if not exist( gtpath + ngtcnf ) then
  begin
    writeln(pname,' ERROR: Cannot access ', gtpath, ngtcnf );
    halt(1);
  end;

  Assign( gtcnf, gtpath + ngtcnf );
  Reset(gtcnf);
  while not eof(gtcnf) do
   begin
     readln(gtcnf, ln);
     choice := copy(ln,1,2);
     if choice = 'DD' then
       bullpath := copy(ln, 4, length(ln)-3)
     else if choice = 'WF' then
       val(copy(ln, 4, length(ln)-3), windowf, z)
     else if choice = 'WR' then
       val(copy(ln, 4, length(ln)-3), frame, z)
     else if choice = 'HF' then
       val(copy(ln, 4, length(ln)-3), high, z)
     else if choice = 'TF' then
       val(copy(ln, 4, length(ln)-3), status, z)
     else if choice = 'OF' then
       val(copy(ln, 4, length(ln)-3), lo, z)
     else if choice = 'CF' then
       val(copy(ln, 4, length(ln)-3), chatf, z)
     else if choice = 'WU' then
       val(copy(ln, 4, length(ln)-3), title, z)
     else if choice = 'BB' then
       bbscbs := copy(ln, 4, length(ln)-3);
   end; {while not eof}
  Close(gtcnf);

  if bullpath[length(bullpath)] <> '\' then
    bullpath := bullpath + '\';

END; {Initialize}
(**************************************************************************)
PROCEDURE OpeningScreen;

begin

 clrscr;
 DrawOpening( pname, ver, copyright_date, 14, 15 );

end; {OpeningScreen}
(**************************************************************************)
Procedure ParseGTDDIR;

const
  ngtddir = 'GTDDIR.BBS';

var
    fi : text;
    g : integer;
    cstr,x,y : string;

begin

if exist(gtpath + ngtddir) then
  assign( fi, gtpath + ngtddir )
else if exist( bbscbs + ngtddir ) then
  assign( fi, bbscbs + ngtddir )
else
begin
  writeln('  ERROR:  Cannot access ', ngtddir, ' in either of these directories:');
  writeln(' GTPATH:  ', gtpath );
  writeln('BBS/CBS:  ', bbscbs );
  halt(1);
end;

{$i-} Reset( fi ); {i+}

c := 0;
while not eof( fi ) do
begin
 readln( fi, x );
 inc( c );
 {divide string x into its components}
 str(c,cstr);
 if wordcnt( x ) = 1 then
   doorname[c] := 'Door #' + cstr
 else if wordcnt( x ) >= 2 then
 begin
   y := ExtractWords(2,1,x);  { door description }
   doorname[c] := copy(y, 2, length(y)-2);  { strip []'s }
   repeat
     g := pos('_',doorname[c]);
     if g <> 0 then
       doorname[c] := copy(doorname[c],1,g-1) + #32 + copy(doorname[c],g+1,length(doorname[c])-g);
   until pos('_',doorname[c]) = 0;
   if length(doorname[c]) = 15 then
     doorname[c] := copy(doorname[c],1,13) + '..';
 end;
end;

end; {ParseGTDDIR}
(**************************************************************************)
Procedure ParseDWORKLOG;

label
  1;

var
  f : text;
  x : string[80];
  i,j : integer;
  p : array[1..12] of string[30];
  dnum : word;
  timein : word;
  recread : word;
  lastline : string[80];

begin

  for i := 1 to 999 do
  begin
    time_in_door[i] := 0;
    times_opened[i] := 0;
  end;

  if exist(trcpath+nlog) then
  begin
    assign( f, trcpath + nlog );
    {$i-} Reset( f ); {i+}
  end
  else
  begin
    writeln('ERROR: Cannot access ',trcpath,nlog);
    halt(1);
  end;

  recread := 0;
  x := '';
  while not eof( f ) do
  begin

    lastline := x;
    readln( f, x );
    inc(recread);

    for i := 1 to 12 do
      p[i] := ExtractWords(i,1,x);

    if recread = 1 then
    begin
      val(p[3],j,i);
      sincedate := months[j] + ' ' + p[4] + ', ' + p[5];
    end;

   if p[1]<>'I' then
    begin
       if (lastline<>'') and ( extractwords(10,2,lastline) = p[10]+' '+p[11] ) then
        {v2.11: We must be sure name from last line matches before adding to totals}
        begin
          val( p[1], dnum, i );
          val( p[2], timein, i );
          {add time to door total}
          time_in_door[dnum] := time_in_door[dnum] + timein;
          {increment times opened}
          inc( times_opened[dnum] );
        end;
    end;

1:end; {while..do}

end; {ParseDWORKLOG}
(**************************************************************************)
Procedure WriteReport( op : char );

const
  bar = '';
  asciibar = '*';
  space30 = '                           ';

var
  d : word;
  f,f2 : text;
  i,j : word;
  k : longint;
  l,s,s2 : string;
  t_open : string[8];
  t_in : string[8];
  totaltime : longint;
  totalopen : longint;

begin

 Assign( f, bullpath + paramstr(1) );
 hue[1] := #27 + '[0;34m';
 hue[2] := #27 + '[0;32m';
 hue[3] := #27 + '[0;36m';
 hue[4] := #27 + '[0;31m';
 hue[5] := #27 + '[0;35m';
 hue[6] := #27 + '[0;33m';
 hue[7] := #27 + '[0m';
 hue[8] := #27 + '[1;30m';
 hue[9] := #27 + '[1;34m';
 hue[10] := #27 + '[1;32m';
 hue[11] := #27 + '[1;36m';
 hue[12] := #27 + '[1;31m';
 hue[13] := #27 + '[1;35m';
 hue[14] := #27 + '[1;33m';
 hue[15] := #27 + '[1;37m';

 {$i-} Rewrite( f ); {$i+}

 writeln(f,'');
 writeln(f,copy(space30,1,14),'Door History from ',sincedate,' through ',months[m],' ',day,', ',year);
 writeln(f, divider3);
 writeln(f, copy(space30,1,3), pname,' ',ver,', (c) Copyright Cory Wright ',copyright_date);
 writeln(f, divider3);
 writeln(f,'');
 writeln(f, copy(space30,1,2), 'Door Name (Min/#Opens): Usage bar');
 writeln(f,'');

 totaltime := 0;
 totalopen := 0;

 d := 0;
 repeat
  inc(d);
 until (time_in_door[d] = 0) and (times_opened[d] = 0);
 c := d-1;


 for i := 1 to c do    {since sorted, just go until first 0 time/open door}
 begin
   totaltime := totaltime + time_in_door[i];
   totalopen := totalopen + times_opened[i];

   str(time_in_door[i],t_in);
   str(times_opened[i],t_open);

   l := ' ('+t_in+'/'+t_open+'): ';
   j := 26 - length(doorname[i]) - length(l);
   doorname[i] := doorname[i] + copy(space30,1,j);
   s := copy(doorname[i],1,26-length(l));
   s := s + copy(space30,1,26-length(s)-length(l)) + l;

   write(f, s);

   k := trunc(50*time_in_door[i]/time_in_door[1]);
   for j := 1 to k do
     write(f, asciibar);
   writeln(f, '|');
 end; {for}

 writeln(f,'');
 writeln(f, divider3);
 writeln(f, 'Total time used in doors: ', trunc(totaltime/60), ' hours ',
   (totaltime-(trunc(totaltime/60)*60)), ' minutes since ',sincedate );
 writeln(f, ' Total # of doors opened: ', totalopen );
 writeln(f, divider3);
 writeln(f, '');
 
 close( f );

 if op = 'C' then
 begin
  Assign( f, bullpath + paramstr(1) );
  Assign( f2, bullpath + paramstr(1) + cbs );
  {$i-} Reset(f); Rewrite(f2); {$i+}
  readln(f,s);
  writeln(f2, s);
  readln(f,s);
  writeln(f2, hue[high], s);
  readln(f,s);
  writeln(f2, hue[frame], divider2);
  readln(f,s);
  writeln(f2, hue[chatf], s);
  readln(f,s);
  writeln(f2, hue[frame], divider2);
  readln(f,s);
  writeln(f2, s);
  readln(f,s);
  write(f2, hue[high],copy(space30,1,2),'Door Name ',hue[lo],'(',hue[chatf],'Min',hue[lo],'/',hue[chatf],'#Opens');
  writeln(f2, hue[lo],'): ',hue[title], 'Usage bar');
  readln(f,s);
  writeln(f2,s);
  for i := 1 to c do
  begin
    readln(f,s);
     s2 := hue[high]+copy(s,1,pos('(',s)-1)+hue[lo]+'('+hue[chatf]+copy(s,pos('(',s)+1,pos('/',s)-pos('(',s)-1);
     s2 := s2 + hue[lo]+'/'+hue[chatf]+copy(s,pos('/',s)+1,pos(')',s)-pos('/',s)-1)+hue[lo]+'): '+hue[title];
     if pos(asciibar,s) <> 0 then
     begin
       for j := pos(asciibar,s) to (pos('|',s)-1) do
         s2 := s2 + bar;
       s2 := s2 + #221;
     end
     else
       s2 := s2 + #221;

    writeln(f2,s2);
  end;
  writeln(f2,'');
  writeln(f2, hue[frame], divider2);
  writeln(f2, hue[chatf],'Total time used in doors: ',hue[title],trunc(totaltime/60),hue[chatf],' hours ',hue[title],
    (totaltime-(trunc(totaltime/60)*60)),hue[chatf],' minutes since ',hue[title],sincedate );
  writeln(f2, hue[chatf],' Total # of doors opened: ',hue[title],totalopen );
  writeln(f2, hue[frame], divider2);
  writeln(f2,hue[7]);
  close(f);
  close(f2);
 end; {if op .. then}

end; {WriteReport}
(**************************************************************************)

BEGIN {Main Code}

directvideo := false;

if paramcount = 0 then
begin
  writeln;
  writeln('DWORKLOG: You must place a bulletin number on the command line!');
  writeln(' Example: DWORKLOG 100');
  writeln;
  halt(1);
end;

writeln('Initializing...');
Initialize;

OpeningScreen;

writeln;

textcolor(7);
writeln('- Parsing GTDDIR.BBS door information file');
ParseGTDDIR;

writeln('- Parsing DWORKDOR.LOG and compiling door information');
ParseDWORKLOG;

writeln('- Ranking doors in order of popularity (total minutes used)');
Sort( time_in_door, c );

writeln('- Writing ASCII bulletin:  ', bullpath, paramstr(1) );
WriteReport('B');  {BBS file}
writeln('- Writing ANSI bulletin:   ', bullpath, paramstr(1), cbs );
WriteReport('C');  {CBS file}


writeln;
DrawClosing( 14, 15 );

end.
