(* Released into the public domain April 1, 1995.  No warranties, use at *)
(* your own risk.  Copyright Jason Cory Wright 1995                      *)

Program DWORKREG;

type
   STRING4       = STRING[4];
   STRING255     = STRING[255];


var
  fin, fout : text;
  crc : string;
  pstr : string255;
  crc_reg_1    : INTEGER;
  crc_reg_2    : INTEGER;
  crc_reg_3    : INTEGER;
  crc_reg_4    : INTEGER;
  crc_reg_5    : INTEGER;
  crc_input    : INTEGER;
  regname      : string255;
  bbs,ser,ext : string;
  i : integer;



(****************************************************************************)
PROCEDURE crc80_calc;

   BEGIN
      inline($B9/>$08);     { mov cx,8    }
      inline($A1/crc_input);    { mov ax,crc_input  }
      inline($D0/$D8);      {  u12: rcr al,1    }
      inline($8B/$1E/crc_reg_5);  { mov     bx,crc_reg_5  }
      inline($D1/$DB);      { rcr     bx,1    }
      inline($89/$1E/crc_reg_5);  { mov     crc_reg_5,bx  }
      inline($8B/$1E/crc_reg_4);  { mov     bx,crc_reg_4  }
      inline($D1/$DB);      { rcr     bx,1    }
      inline($89/$1E/crc_reg_4);  { mov     crc_reg_4,bx  }
      inline($8B/$1E/crc_reg_3);  { mov     bx,crc_reg_3  }
      inline($D1/$DB);      { rcr     bx,1    }
      inline($89/$1E/crc_reg_3);  { mov     crc_reg_3,bx  }
      inline($8B/$1E/crc_reg_2);  { mov     bx,crc_reg_2  }
      inline($D1/$DB);      { rcr     bx,1    }
      inline($89/$1E/crc_reg_2);  { mov     crc_reg_2,bx  }
      inline($8B/$1E/crc_reg_1);  { mov     bx,crc_reg_1  }
      inline($D1/$DB);      { rcr     bx,1    }
      inline($89/$1E/crc_reg_1);  { mov     crc_reg_1,bx  }
      inline($73/$03);      { jnc u22   }
      inline($EB/$06/$90);    { jmp u33   }
      inline($E2/$C5);      {  u22: loop  u12             }
      inline($EB/$3F/$90);    { jmp u44   }
      inline($8B/$1E/crc_reg_1);  {  u33: mov     bx,crc_reg_1  }
      inline($81/$F3/$B25D);    { xor bx,8321h  }
      inline($89/$1E/crc_reg_1);  { mov     crc_reg_1,bx  }
      inline($8B/$1E/crc_reg_2);  { mov     bx,crc_reg_2  }
      inline($81/$F3/$A84F);    { xor bx,5DB6h  }
      inline($89/$1E/crc_reg_2);  { mov     crc_reg_2,bx  }
      inline($8B/$1E/crc_reg_3);  { mov     bx,crc_reg_3  }
      inline($81/$F3/$C64C);    { xor bx,2141h  }
      inline($89/$1E/crc_reg_3);  { mov     crc_reg_3,bx  }
      inline($8B/$1E/crc_reg_4);  { mov     bx,crc_reg_4  }
      inline($81/$F3/$9E7D);    { xor bx,7EA9h  }
      inline($89/$1E/crc_reg_4);  { mov     crc_reg_4,bx  }
      inline($8B/$1E/crc_reg_5);  { mov     bx,crc_reg_5  }
      inline($81/$F3/$09BB);    { xor bx,1D54h  }
      inline($89/$1E/crc_reg_5);  { mov     crc_reg_5,bx  }
      inline($EB/$BD);      { jmp     u22   }
      inline($90);      {  u44: nop                     }
    END;
(****************************************************************************)
   FUNCTION
      Hex( h : INTEGER ) : STRING4;
   VAR
      ans  : STRING4;
      hh   : INTEGER;
      dh   : INTEGER;
      i    : INTEGER;
   BEGIN
      ans:='    ';
      hh:=h;
      FOR i:=4 DOWNTO 1 DO BEGIN
         dh:=hh AND $000F;
         hh:=hh shr 4;
         IF dh<10 THEN
            ans[i]:=CHR(ORD('0')+dh)
         ELSE
            ans[i]:=CHR(ORD('A')+dh-10);
      END;
      Hex:=ans;
   END;
(****************************************************************************)
   PROCEDURE
       calculate(VAR s : string255);
   VAR
       j    : INTEGER;
   BEGIN
       crc_reg_1:=0;
       crc_reg_2:=0;
       crc_reg_3:=0;
       crc_reg_4:=0;
       crc_reg_5:=0;
       FOR j:=1 TO Length(s) DO BEGIN
           crc_input:=ORD(s[j])+16;
           crc80_calc;
       END;
       crc_input:=0;
       FOR j:=1 TO 10 DO
           crc80_calc;
   END;
(**************************************************************************)

begin

regname := '';

assign(fin, 'mregtxt.dat');
reset( fin );
readln( fin, bbs );
readln( fin, ser );  {this value is already mult. by 5 when written}
close( fin );

  ext := '';
  for i := length(bbs) downto 1 do
     ext := ext + bbs[i];

  regname := bbs + ser + ext;

  Calculate(regname);

  { Determine registration }
  crc := Hex(crc_reg_5) + '-' + Hex(crc_reg_1);

Assign( fout, 'mregtxt.dat' );
Rewrite( fout );

writeln( fout, bbs );
writeln( fout, ser );
writeln( fout, crc );

Close( fout );

end.
