(* Released into the public domain April 1, 1995.  No warranties, use at *)
(* your own risk.  Copyright Jason Cory Wright 1995                      *)
{$M $6000, $0, $16000}
{$N+,E+}   {Emulate 8087 to process reals/doubles}
PROGRAM DWORKS;

(*************************************************************************
 DoorWorks Door Conversion Manager for GT Power BBS Systems
 Formerly The GTGap (conceived June 14, 1989, begin translation to Pascal - 5/24/90)
 Copyright Cory Wright 1991-1995
 *************************************************************************
 NOTE:  ENCRYPTED TEXT IS CREATED WITH ENCRYPT2.PAS/ENCRYPT2.EXE
        to ENCRYPT.TXT

 4.01 released - full version, works forever with GT19.
 *************************************************************************
 4.00beta1 work begins 5/22/94, GT 18beta2 and above compatible
 ZIP package renamed to DWORX4B1.ZIP, for beta
 Release versions will be named DWORX400.ZIP, DWORX410.ZIP, etc
 user.level is now longint, added chr() and ord() in a couple places where
   needed.  lvl is main driver for level and it gets that from GTUSER.BBS
   where it is still in character form.
 User file named "_USER.CTL" now.  Changed instances of that here.
 WC and RA used birthdates in the form MM/DD/YY.  If birthday is verified
   in GT19, use real birthdate, else default to 01/01/70.
 For GT19beta2 and above, must change GT version to "19.00" in config.
   DoorWorks will stop if it finds a version below 19.00.
 *************************************************************************
 3.00 released 05/21/94, final version for 15-18.
 *************************************************************************
 Small adjustments to code format, no functional changes worth noting
 Code expires at the end of 1994
 v2.92 released 11/30/1993, expires 12/31/94
 *************************************************************************
 New work started on 2.91beta as of 10/06/93
 Adjustments include
   adding SRDOOR file format for Barron Realms, Solar Realms, AC6 (?) as
     suggested by Stephen Schauer 092/021
   deleted "quick" annoucement option to com port and shortened the broadcast
   changed DWORKS.NDX file to DWORKS.IDX file for beta and recoded slightly
     to see if we can track down errors
   beta code expires end of November
   compiled for 286 and above for this version only.
   modified chopnull -- replaced strip fn with custom "chopping" at first null
   added RESET option to delete DWORKDOR.LOG and DWORKDOR.TIM files
   added /TOP###:X option to give top ### used doors reporting... will change
     in future to be different looking from /DOORGRAPH if wanted/requested.
 2.91b released 10/31/1993, expires 11/30/93
 *************************************************************************
 New work started on 2.90beta on the way to 3.0 as of 9/29/1993
 Adjustments for 2.90beta (9/29/1993)
  changed outgoing announcement to one line standard, 2 line event
  incorporated door usage graphs into program with /DOORGRAPH:X
  no fixes on index file, waiting to hear from users
  title screen switch
  added pre-event wait field to allow for var waits, decided against going
    out to look for it in the host batch file.
  now "compatible" with GT 18, although the code was not changed specifically
    for that purpose.
  fixed time calculation problems with rolling over midnight (I think).
  no fixes or addition to door file support.. need to investigate.
 2.90b released 10/01/1993, expires 10/31/93
 *************************************************************************
 The DoorWorks Project - began August 24, 1990
 *************************************************************************)

Uses Dos, Crt, YASync, MiscTTT5, StrnTTT5, FastTTT5, KeyTTT5, TRCSTD93, SHOWSCRN, DWORKSU;

CONST
{$I DWSCREEN.PAS}    {Definitions for opening DoorWorks screen}
  BufferSize = 4096; { Transmit and receive buffers }
         ver = '4.10F';
    ver_date = '4/1/1995';       {always of the form M/D/YYYY}
       pname = 'DoorWorks';
copyright_date = '1990-1995.';
      ngtcnf = 'GT.CNF';
         ndb = 'DWORKS.DB';
        ncnf = 'DWORKS.CNF';
        nerr = 'DWORKS.ERR';
        nlog = 'DWORKDOR.LOG';
   ntimetext = 'DWORKDOR.TIM';
indxfilename = 'DWORKS.IDX';
         cbs = '.CBS';
        crlf = chr(13) + chr(10);
     divider = '';
    divider2 = '';
    divider3 = '------------------------------------------------------------------------------';
        days : array[0..6] of string[3] = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
      months : array[1..12] of string[3] = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

TYPE
  string80 = string[80];
  string255 = string[255];
  string4 = string[4];
  characters = string[255];
  HueType  = Array[1..15] of String[7];
  BReal  = array[0..3] of byte;

  {used in log reporter}
  elementarray = array[1..999] of longint;

  {used by UNCRUNCH to show opening screen}
  ScreenType = array [0..3999] of Byte;

  ScreenWindowType = Record
  { Control information for screen window }
    WindowOk : Boolean;
    Rate : LongInt;   { Data rate in bits per second }
    ComPort : Word;   { Serial port number }
    Bits : Word;      { Number of data bits }
    Stop : Word;      { Number of stop bits }
    ErrorCount : Word;   { Number of error interrupts }
    OverrunCount : Word; { Number of overrun errors }
    ParityCount : Word;  { Number of parity errors }
    FrameCount : Word;   { Number of framing errors }
    BreakCount : Word;   { Number of break signals received }
    TimeoutCount : Word; { Number of timeouts }
    Parity : Char;    { Parity (N,E,O,0,1) }
    HandShake : Char; { Handshaking option (N,D,C,X) }
    Echo : Char;      { Echo option (N,E) }
    WinX1, WinY1, WinX2, WinY2, CursorX, CursorY : Byte;
    Message : String[80];
  End;

{$I d:\bp\theworks\t.def}

     dwcnf = RECORD
          bbs : string[65];
       serial : integer;
          crc : string[11];
     sysfirst : string[31];
      syslast : string[31];
          dis : boolean;
          prn : boolean;
          bel : boolean;
          ala : boolean;
         lock : word;
           sl : integer;
      kickoff : integer;
    minexpire : integer;
        hayes : boolean;
      windows : boolean;
    gtversion : real;
    biosvideo : boolean;
     usercaps : boolean;
       editor : string[40];
   usenetwork : boolean;
      defline : string[80];
   enhancelog : boolean;
 write_dorlog : boolean;
preevent_wait : integer;   {added in 2.90b to allow variable preevent wait, cannot be > 60 min}
       filler : string[36];
  end; {dwcnf}

  ndxrec = RECORD
             rec : longint;
           end; {ndxrec}

  dbrec = RECORD
           doorname : string[30]; {Door's Name}
         conversion : string[8];  {Conversion type}
           minlevel : char;       {Minimum level to use door}
            overlay : boolean;    {Overlay this door?}
              simul : boolean;    {FALSE=allow only one at a time}
            minbaud : word;       {Minimum baud rate to use door}
            reqansi : boolean;    {require ANSI to use door?}
     filedispbefore : string[12]; {file in \%GTPATH%\TRC directory
                                   to display before entering door}
     filedispafter  : string[12]; { ... after exiting door}
             filler : string[32];
          end; {dbrec}

VAR
 doserror  : integer;
 i,j,k,z,e : integer;

 c : word;           {used in usage log reporter}
 bulletin_number : string;
 top_number_str : string;  {used in top usage log reporter}
 top_number : integer;

 {Used by UNCRUNCH to show screen}
 ScreenAddr : ScreenType absolute $B800:$0000;

  msg : MessageRecord;
 fmsg : file of MessageRecord;
 user : GT19UserRecord;
fuser : file of GT19UserRecord;
  cnf : dwcnf;
 fcnf : file of dwcnf;
   db : dbrec;
  fdb : file of dbrec;
  ndx : NDXREC;
 flog : text;  {named of nlog}

{ NDX operational variables}
           sk : longint;
numberofusers : longint;
    usercount : longint;

{ Color variables }
    hue : huetype;
windowf : integer;
  chatf : integer;
  title : integer;
  hi,lo : integer;
 status : integer;
  frame : integer;

{ Registration variables }
  pstr : CHARACTERS;
  crc_reg_1    : INTEGER;
  crc_reg_2    : INTEGER;
  crc_reg_3    : INTEGER;
  crc_reg_4    : INTEGER;
  crc_reg_5    : INTEGER;
  crc_input    : INTEGER;
  regname      : string255;
  regcrc       : string;
  realcrc      : string;
  registered   : boolean;
  regcolor     : integer;
  regtag       : string;


{ Expiration Date variables }
  y, m, d, dow : word;

 {Date Variables -- used in log reporter}
 sincedate : string[12];
 day, year : string;

{ Environmental variables }
    gtpath : string;
   lanpath : string;
   logpath : string;
   trcpath : string;
    bbscbs : string;
  bullpath : string;
currentdir : string;
includetxt : boolean;

{ System variables }
    port : integer;
     com : string;
    node : string;
   dbpos : integer; {points to door record}
 cmdline : string;  {contains command line}

{Door Logout vars}
  time_in_door : string[5];
  dnum : integer;
  ln : string[80];
  f : text;

{ Calcuation vars }
  time_in_door_ARRAY : elementarray; {longint}
  times_opened : array[1..999] of word;
      doorname : array[1..999] of string[15];

{ USER Info }
  t,u,v,w,x  : string;
  userrec : word;  { user record number }
  dce_not_avail : boolean;
  param : ARRAY [1..10] of String[30];

  fname : string;
  lname : string;
  full  : string;
  lvl   : string[1];
  auth  : string;
  dce   : word;
  dte   : word;
  ansi  : boolean;
  timeon : integer;
  timeleft : integer;
  tillevent : integer;
  logontime : string;
  showlogontime : string;
  logontimeinmin : integer;
  phone  : string;
  location : string;
  currenttime : string;
  showcurrenttime : string;
  showdate : string;
  pm : string;
  ldate : string;

  lhour, lmin  :  integer;

  hour, minute, sec, sec100 : word;
  maintimeleft :  integer;
  min : integer;

{ door variables }
  convtype : string;
       loc : string;
      itxt : string;  {filename of included text file}
     ctype : string;  {type of door to convert to}

{ Communications variables }
  ScreenWindow : Array[1..MaxPorts] Of ScreenWindowType;
  Done : Boolean;
  Ch : Char;
  Rate : LongInt;   { Data rate in bits per second }
  Bits : Word;      { Number of data bits }
  Stop : Word;      { Number of stop bits }
  ErrorCount : Word;   { Number of error interrupts }
  OverrunCount : Word; { Number of overrun errors }
  ParityCount : Word;  { Number of parity errors }
  FrameCount : Word;   { Number of framing errors }
  BreakCount : Word;   { Number of break signals received }
  TimeoutCount : Word; { Number of timeouts }
  Parity : Char;    { Parity (N,E,O,0,1) }
  HandShake : Char; { Handshaking option (N,D,C,X) }
  Echo : Char;      { Echo option (N,E) }

(****************************************************************************)
{$I DWORKS2.PAS}   {Registration/decryption algorithm,openfuser,etc}
(****************************************************************************)
(* THE FOLLOWING IS CODE USED BY THE LOG REPORTER                           *)
(****************************************************************************)
{for sorting of type elementarray -- used in door use sorting by log reporter}
PROCEDURE Sort( var a : elementarray; n : integer );

var
  i,j,bottom,top,middle : integer;
  temp : longint;
  temp2 : string[15];
  temp3 : word;
  t1 : array[1..999] of longint;
  t2 : array[1..999] of string[15];
  t3 : array[1..999] of word;

begin
  for i := 2 to n do
  begin
    temp := a[i];
    temp2 := doorname[i];
    temp3 := times_opened[i];
    bottom := 1; top := i-1;
    while bottom <= top do
    begin
      middle := (bottom + top) div 2;
      if temp < a[middle] then
        top := middle - 1
      else
        bottom := middle + 1;
    end; {while}
    for j := i - 1 downto bottom do
    begin
      a[j+1] := a[j];
      doorname[j+1] := doorname[j];
      times_opened[j+1] := times_opened[j];
    end;

    a[bottom] := temp;
    doorname[bottom] := temp2;
    times_opened[bottom] := temp3;

  end; {for}

  j := 0;
  {Convert ascending to descending}
  for i := c downto 1 do
  begin
    inc(j);
    t1[j] := a[i];
    t2[j] := doorname[i];
    t3[j] := times_opened[i];
  end;

  for i := 1 to c do
  begin
    a[i] := t1[i];
    doorname[i] := t2[i];
    times_opened[i] := t3[i];
  end;

end; {Sort}
(**************************************************************************)
{used by log reporter}
Procedure ParseGTDDIR;

const
  ngtddir = 'GTDDIR.BBS';

var
    fi : text;
    g : integer;
    cstr,x,y : string;

begin

if exist(gtpath + ngtddir) then
  assign( fi, gtpath + ngtddir )
else if exist( bbscbs + ngtddir ) then
  assign( fi, bbscbs + ngtddir )
else
begin
  writeln('  ERROR:  Cannot access ', ngtddir, ' in either of these directories:');
  writeln(' GTPATH:  ', gtpath );
  writeln('BBS/CBS:  ', bbscbs );
  halt(1);
end;

{$i-} Reset( fi ); {i+}

c := 0;
while not eof( fi ) do
begin
 readln( fi, x );
 inc( c );
 {divide string x into its components}
 str(c,cstr);
 if wordcnt( x ) = 1 then
   doorname[c] := 'Door #' + cstr
 else if wordcnt( x ) >= 2 then
 begin
   y := ExtractWords(2,1,x);  { door description }
   doorname[c] := copy(y, 2, length(y)-2);  { strip []'s }
   repeat
     g := pos('_',doorname[c]);
     if g <> 0 then
       doorname[c] := copy(doorname[c],1,g-1) + #32 + copy(doorname[c],g+1,length(doorname[c])-g);
   until pos('_',doorname[c]) = 0;
   if length(doorname[c]) = 15 then
     doorname[c] := copy(doorname[c],1,13) + '..';
 end;
end;

end; {ParseGTDDIR}
(**************************************************************************)
{used by log reporter}
Procedure ParseDWORKLOG;

label
  1;

var
  f : text;
  x : string[80];
  i,j : integer;
  p : array[1..12] of string[30];
  dnum : word;
  timein : word;
  recread : word;
  lastline : string[80];

begin

  for i := 1 to 999 do
  begin
    time_in_door_ARRAY[i] := 0;
    times_opened[i] := 0;
  end;

  if exist(trcpath+nlog) then
  begin
    assign( f, trcpath + nlog );
    {$i-} Reset( f ); {i+}
  end
  else
  begin
    writeln('ERROR: Cannot access ',trcpath,nlog);
    halt(1);
  end;

  recread := 0;
  x := '';
  while not eof( f ) do
  begin

    lastline := x;
    readln( f, x );
    inc(recread);

    for i := 1 to 12 do
      p[i] := ExtractWords(i,1,x);

    if recread = 1 then
    begin
      val(p[3],j,i);
      sincedate := months[j] + ' ' + p[4] + ', ' + p[5];
    end;

   if p[1]<>'I' then
    begin
       if (lastline<>'') and ( extractwords(10,2,lastline) = p[10]+' '+p[11] ) then
        {v2.11: We must be sure name from last line matches before adding to totals}
        begin
          val( p[1], dnum, i );
          val( p[2], timein, i );
          {add time to door total}
          time_in_door_ARRAY[dnum] := time_in_door_ARRAY[dnum] + timein;
          {increment times opened}
          inc( times_opened[dnum] );
        end;
    end;

1:end; {while..do}

end; {ParseDWORKLOG}
(**************************************************************************)
{used by log reporter to write bulletins (reports)}
{B=complete .bbs; C=complete .cbs}
Procedure WriteReport( op : char; bulletin_number : string );

const
  bar = '';
  asciibar = '*';
  space30 = '                           ';

var
  d : word;
  f,f2 : text;
  i,j : word;
  k : longint;
  l,s,s2 : string;
  t_open : string[8];
  t_in : string[8];
  totaltime : longint;
  totalopen : longint;

begin

 Assign( f, bullpath + bulletin_number );
 hue[1] := #27 + '[0;34m';
 hue[2] := #27 + '[0;32m';
 hue[3] := #27 + '[0;36m';
 hue[4] := #27 + '[0;31m';
 hue[5] := #27 + '[0;35m';
 hue[6] := #27 + '[0;33m';
 hue[7] := #27 + '[0m';
 hue[8] := #27 + '[1;30m';
 hue[9] := #27 + '[1;34m';
 hue[10] := #27 + '[1;32m';
 hue[11] := #27 + '[1;36m';
 hue[12] := #27 + '[1;31m';
 hue[13] := #27 + '[1;35m';
 hue[14] := #27 + '[1;33m';
 hue[15] := #27 + '[1;37m';

 {$i-} Rewrite( f ); {$i+}

 writeln(f,'');
 writeln(f,copy(space30,1,14),'Door History from ',sincedate,' through ',months[m],' ',day,', ',year);
 writeln(f, divider3);
 writeln(f, copy(space30,1,3), pname,' ',ver,', Copyright ',copyright_date,' Cory Wright');
 writeln(f, divider3);
 writeln(f,'');
 writeln(f, copy(space30,1,2), 'Door Name (Min/#Opens): Usage bar');
 writeln(f,'');

 totaltime := 0;
 totalopen := 0;

 d := 0;
 repeat
  inc(d);
 until (time_in_door_ARRAY[d] = 0) and (times_opened[d] = 0);
 c := d-1;


 for i := 1 to c do    {since sorted, just go until first 0 time/open door}
 begin
   totaltime := totaltime + time_in_door_ARRAY[i];
   totalopen := totalopen + times_opened[i];
 end;

 for i := 1 to c do
 begin
   str(time_in_door_ARRAY[i],t_in);
   str(times_opened[i],t_open);

   l := ' ('+t_in+'/'+t_open+'): ';
   j := 26 - length(doorname[i]) - length(l);
   doorname[i] := doorname[i] + copy(space30,1,j);
   s := copy(doorname[i],1,26-length(l));
   s := s + copy(space30,1,26-length(s)-length(l)) + l;

   write(f, s);

   k := trunc(50*time_in_door_ARRAY[i]/totaltime);
   for j := 1 to k do
     write(f, asciibar);
   writeln(f, '|');
 end; {for}

 writeln(f,'');
 writeln(f, divider3);
 writeln(f, 'Total time used in doors: ', trunc(totaltime/60), ' hours ',
   (totaltime-(trunc(totaltime/60)*60)), ' minutes since ',sincedate );
 writeln(f, ' Total # of doors opened: ', totalopen );
 writeln(f, divider3);
 writeln(f, '');

 close( f );

 if op = 'C' then
 begin
  Assign( f, bullpath + bulletin_number );
  Assign( f2, bullpath + bulletin_number + cbs );
  {$i-} Reset(f); Rewrite(f2); {$i+}
  readln(f,s);
  writeln(f2, s);
  readln(f,s);
  writeln(f2, hue[hi], s);
  readln(f,s);
  writeln(f2, hue[frame], divider2);
  readln(f,s);
  writeln(f2, hue[chatf], s);
  readln(f,s);
  writeln(f2, hue[frame], divider2);
  readln(f,s);
  writeln(f2, s);
  readln(f,s);
  write(f2, hue[hi],copy(space30,1,2),'Door Name ',hue[lo],'(',hue[chatf],'Min',hue[lo],'/',hue[chatf],'#Opens');
  writeln(f2, hue[lo],'): ',hue[title], 'Usage bar');
  readln(f,s);
  writeln(f2,s);
  for i := 1 to c do
  begin
    readln(f,s);
     s2 := hue[hi]+copy(s,1,pos('(',s)-1)+hue[lo]+'('+hue[chatf]+copy(s,pos('(',s)+1,pos('/',s)-pos('(',s)-1);
     s2 := s2 + hue[lo]+'/'+hue[chatf]+copy(s,pos('/',s)+1,pos(')',s)-pos('/',s)-1)+hue[lo]+'): '+hue[title];
     if pos(asciibar,s) <> 0 then
     begin
       for j := pos(asciibar,s) to (pos('|',s)-1) do
         s2 := s2 + bar;
       s2 := s2 + #221;
     end
     else
       s2 := s2 + #221;

    writeln(f2,s2);
  end;
  writeln(f2,'');
  writeln(f2, hue[frame], divider2);
  writeln(f2, hue[chatf],'Total time used in doors: ',hue[title],trunc(totaltime/60),hue[chatf],' hours ',hue[title],
    (totaltime-(trunc(totaltime/60)*60)),hue[chatf],' minutes since ',hue[title],sincedate );
  writeln(f2, hue[chatf],' Total # of doors opened: ',hue[title],totalopen );
  writeln(f2, hue[frame], divider2);
  writeln(f2,hue[7]);
  flush(f);      {added for extra assurance.. dunno if needed}
  flush(f2);
  close(f);
  close(f2);
 end; {if op .. then}

end; {WriteReport}
(**************************************************************************)
{used by top X log reporter to write bulletins (reports)}
{B=complete .bbs; C=complete .cbs}
Procedure WriteTOPReport( op : char; bulletin_number : string );

const
  bar = '';
  asciibar = '*';
  space30 = '                           ';

var
  d : word;
  f,f2 : text;
  i,j : word;
  k : longint;
  l,s,s2 : string;
  t_open : string[8];
  t_in : string[8];
  totaltime : longint;
  totalopen : longint;

begin

 Assign( f, bullpath + bulletin_number );
 hue[1] := #27 + '[0;34m';
 hue[2] := #27 + '[0;32m';
 hue[3] := #27 + '[0;36m';
 hue[4] := #27 + '[0;31m';
 hue[5] := #27 + '[0;35m';
 hue[6] := #27 + '[0;33m';
 hue[7] := #27 + '[0m';
 hue[8] := #27 + '[1;30m';
 hue[9] := #27 + '[1;34m';
 hue[10] := #27 + '[1;32m';
 hue[11] := #27 + '[1;36m';
 hue[12] := #27 + '[1;31m';
 hue[13] := #27 + '[1;35m';
 hue[14] := #27 + '[1;33m';
 hue[15] := #27 + '[1;37m';

 {$i-} Rewrite( f ); {$i+}

 writeln(f,'');
 writeln(f,copy(space30,1,14),'Top ',top_number_str,' Doors from ',sincedate,' through ',months[m],' ',day,', ',year);
 writeln(f, divider3);
 writeln(f, copy(space30,1,3), pname,' ',ver,', Copyright ',copyright_date,' Cory Wright');
 writeln(f, divider3);
 writeln(f,'');
 writeln(f, copy(space30,1,2), 'Door Name (Min/#Opens): Usage bar');
 writeln(f,'');

 totaltime := 0;
 totalopen := 0;

 { find number of doors ranked }
 d := 0;
 repeat
  inc(d);
 until (time_in_door_ARRAY[d] = 0) and (times_opened[d] = 0);
 c := d-1;
 { if top # to rank is lower than # doors ranked, then set c = top # }
 if c > top_number then c := top_number;  {rank only first c doors}

 for i := 1 to c do    {since sorted, just go until first c doors}
 begin
   totaltime := totaltime + time_in_door_ARRAY[i];
   totalopen := totalopen + times_opened[i];
 end;

 for i := 1 to c do
 begin
   str(time_in_door_ARRAY[i],t_in);
   str(times_opened[i],t_open);

   l := ' ('+t_in+'/'+t_open+'): ';
   j := 26 - length(doorname[i]) - length(l);
   doorname[i] := doorname[i] + copy(space30,1,j);
   s := copy(doorname[i],1,26-length(l));
   s := s + copy(space30,1,26-length(s)-length(l)) + l;

   write(f, s);

   k := trunc(50*time_in_door_ARRAY[i]/totaltime);
   for j := 1 to k do
     write(f, asciibar);
   writeln(f, '|');
 end; {for}

 writeln(f,'');
 writeln(f, divider3);
 writeln(f, 'Total time used in top ',top_number_str,' doors: ', trunc(totaltime/60), ' hours ',
   (totaltime-(trunc(totaltime/60)*60)), ' minutes since ',sincedate );
 writeln(f, ' Total # of top ',top_number_str,' doors opened: ', totalopen );
 writeln(f, divider3);
 writeln(f, '');

 close( f );

 if op = 'C' then
 begin
  Assign( f, bullpath + bulletin_number );
  Assign( f2, bullpath + bulletin_number + cbs );
  {$i-} Reset(f); Rewrite(f2); {$i+}
  readln(f,s);
  writeln(f2, s);
  readln(f,s);
  writeln(f2, hue[hi], s);
  readln(f,s);
  writeln(f2, hue[frame], divider2);
  readln(f,s);
  writeln(f2, hue[chatf], s);
  readln(f,s);
  writeln(f2, hue[frame], divider2);
  readln(f,s);
  writeln(f2, s);
  readln(f,s);
  write(f2, hue[hi],copy(space30,1,2),'Door Name ',hue[lo],'(',hue[chatf],'Min',hue[lo],'/',hue[chatf],'#Opens');
  writeln(f2, hue[lo],'): ',hue[title], 'Usage bar');
  readln(f,s);
  writeln(f2,s);
  for i := 1 to c do
  begin
    readln(f,s);
     s2 := hue[hi]+copy(s,1,pos('(',s)-1)+hue[lo]+'('+hue[chatf]+copy(s,pos('(',s)+1,pos('/',s)-pos('(',s)-1);
     s2 := s2 + hue[lo]+'/'+hue[chatf]+copy(s,pos('/',s)+1,pos(')',s)-pos('/',s)-1)+hue[lo]+'): '+hue[title];
     if pos(asciibar,s) <> 0 then
     begin
       for j := pos(asciibar,s) to (pos('|',s)-1) do
         s2 := s2 + bar;
       s2 := s2 + #221;
     end
     else
       s2 := s2 + #221;

    writeln(f2,s2);
  end;
  writeln(f2,'');
  writeln(f2, hue[frame], divider2);
  write(f2, hue[chatf],'Total time used in top ',top_number_str,' doors: ',hue[title],trunc(totaltime/60),hue[chatf]);
    {continued from above line}
    writeln(f2, ' hours ',hue[title], (totaltime-(trunc(totaltime/60)*60)),hue[chatf],' minutes since ',hue[title],sincedate );
  writeln(f2, hue[chatf],' Total # of top ',top_number_str,' doors opened: ',hue[title],totalopen );
  writeln(f2, hue[frame], divider2);
  writeln(f2,hue[7]);
  flush(f);      {added for extra assurance.. dunno if needed}
  flush(f2);
  close(f);
  close(f2);
 end; {if op .. then}

end; {WriteReport}
(**************************************************************************)
(**************************************************************************)
(*   END OF MATERIAL USED BY USAGE LOG CONVERTERS EXCLUSIVELY                    *)
(**************************************************************************)
PROCEDURE Initialize;

var
  gtcnf  : text;
  fjunk  : text;
  ln     : string;
  choice : string;

begin

  Randomize;

  GetDate( y, m, d, dow );
(*
  {$IFDEF BETA_CODE}
  if (y > 1994) then halt;
  if (m > 11) and (y <= 1994) then halt;
  textcolor(12);
  writeln('          ***>  Note:  This is beta code and expires 12/1/1994  <***');
  writeln;
  {$ENDIF}
*)
  str(d, day);
  str(y, year);
  showdate := days[dow] + ' ' + months[m] + ' ' + day + ', ' + year;

  GetDir( 0, currentdir );     {get drive and directory}
  if currentdir[length(currentdir)] <> '\' then
    currentdir := currentdir + '\';

  gtpath := GetEnv('GTPATH');
  if gtpath = '' then
    begin
      writeln;
      writeln('GTPATH is not SET.  SET GTPATH=<gt directory> before continuing.');
      halt( 1 );
    end;

  if gtpath[length(gtpath)] <> '\' then
    gtpath := gtpath + '\';

  trcpath := gtpath + 'TRC\';

  if not exist( gtpath + ngtcnf ) then
  begin
    writeln(pname,' ERROR:  Cannot access ', gtpath, ngtcnf );
    halt(1);
  end;

  Assign( gtcnf, gtpath + ngtcnf );
  Reset(gtcnf);
  while not eof(gtcnf) do
   begin
     readln(gtcnf, ln);
     choice := copy(ln,1,2);
     if choice = 'DD' then
       bullpath := copy(ln, 4, length(ln)-3)
     else if choice = 'CM' then
       com := copy(ln, 4, length(ln)-3)
     else if choice = 'LO' then
       logpath := copy(ln, 4, length(ln)-3)
     else if choice = 'LR' then
       lanpath := copy(ln, 4, length(ln)-3)
     else if choice = 'LN' then
       node := copy(ln, 4, length(ln)-3)
     else if choice = 'WF' then
       val(copy(ln, 4, length(ln)-3), windowf, z)
     else if choice = 'WR' then
       val(copy(ln, 4, length(ln)-3), frame, z)
     else if choice = 'HF' then
       val(copy(ln, 4, length(ln)-3), hi, z)
     else if choice = 'TF' then
       val(copy(ln, 4, length(ln)-3), status, z)
     else if choice = 'OF' then
       val(copy(ln, 4, length(ln)-3), lo, z)
     else if choice = 'CF' then
       val(copy(ln, 4, length(ln)-3), chatf, z)
     else if choice = 'WU' then
       val(copy(ln, 4, length(ln)-3), title, z)
     else if choice = 'BB' then
       bbscbs := copy(ln, 4, length(ln)-3);
   end; {while not eof}
  Close(gtcnf);

  {re-adjust node}
  val(node, i, j);
  inc( i );
  str( i, node );

  {adjust lanpath}
  if (length(lanpath)<>0) and (lanpath[length(lanpath)] <> '\') then
   lanpath := lanpath + '\';

  {adjust logpath}
  if (length(logpath)<>0) and (logpath[length(logpath)] <> '\') then
   logpath := logpath + '\';

  {adjust bbscbs path}
  if (length(bbscbs)<>0) and (bbscbs[length(bbscbs)] <> '\') then
   bbscbs := bbscbs + '\';

  {adjust bulletin path}
  if bullpath[length(bullpath)] <> '\' then
   bullpath := bullpath + '\';

  {adjust port and com}
  val(com, port, e);

  {v2.91b cleans up for past versions, kills old DWORKDOR.TIM file in GTPATH}
  {and any old DWORKS.NDX files for the new DWORKS.IDX file}
  if exist(gtpath+ntimetext) then
  begin
   Assign( fjunk, gtpath + ntimetext );
   {$i-} Erase( fjunk ); {$i+}
  end;

  if exist(trcpath+'dworks.ndx') then
  begin
   Assign( fjunk, trcpath + 'dworks.ndx' );
   {$i-} Erase( fjunk ); {$i+}
  end;

END; {Initialize}
(**************************************************************************)
PROCEDURE CheckRegister;

var
  ser : string;
  ext : string[65];
    i : integer;

begin

  Str(cnf.serial*5, ser);

  ext := '';
  for i := length(cnf.bbs) downto 1 do
     ext := ext + cnf.bbs[i];

  regname := cnf.bbs + ser + ext;

  Calculate(regname);

  { Determine registration }
  { v4.10F of 4/1/1995 is the first FREE version -- no registration required }
  realcrc := Hex(crc_reg_5) + '-' + Hex(crc_reg_1);
  if (realcrc = cnf.crc) and (realcrc <> '0000-0000') and (cnf.crc <> '0000-0000') then
    registered := true
  else
   {registered := false;}
    registered := true;  {v4.10F modification, 4/1/1995}

  if registered then
    begin
     regtag := decrypt('}');
     regcolor := 14;
     textcolor(regcolor);   write(#254,#32,regtag);
     textcolor(7);          write(' to ''');
     textcolor(regcolor);   write(cnf.bbs);
     textcolor(7);          write(''' [#');
     textcolor(regcolor);   write(cnf.serial);
     textcolor(7);          write(']');
    end
  else
    begin
     regtag := decrypt('y}prt~p}po');
     regcolor := 12;
     textcolor(regcolor);
     write(#254,' UNREGISTERED COPY-Please register ',pname,' by mail or online within 30 days.');
    end;

textcolor(7);

end; {CheckRegister}
(**************************************************************************)
PROCEDURE WriteCNF;

var
  i, j, k : integer;

begin
 textcolor( 7 );
 writeln('- Saving settings to ', trcpath, ncnf);
 Assign( fcnf, trcpath + ncnf);
 {$i-}  Rewrite( fcnf ); {$i+}
 if IOResult = 0 then;
 Write( fcnf, cnf);
 close( fcnf );

end; {WriteCNF}
(**************************************************************************)
PROCEDURE ReadCNF;

var
  i,j,k : integer;
  gtpathcnf_exist : boolean;

begin

 {$i-} Mkdir( gtpath + 'TRC' );  {$i+}
 if IoResult = 0 then;

 gtpathcnf_exist := exist(gtpath+ncnf);

 if gtpathcnf_exist then            {added in v2.20 to detect old version of}
   Assign( fcnf, gtpath + ncnf )    {DWORKS.CNF in GTPATH, reads, deletes and}
 else                               {leaves to WriteCNF to write in TRCPATH}
   Assign( fcnf, trcpath + ncnf);

 {$i-}  Reset( fcnf ); {$i+}
 if (IoResult <> 0) or (filesize(fcnf)=0) then {file is not there, make it}
   begin
   fillchar( cnf, sizeof(cnf), #32);
   Rewrite( fcnf );
   with cnf do
     begin
          {default values for CNF file}
          bbs := 'Please Personalize with BBS Name';
       serial := 999;
          crc := '0000-0000';
     sysfirst := '';
      syslast := '';
          dis := true;
          prn := false;
          bel := true;
          ala := true;
         lock := 0;
           sl := 50;
      kickoff := 2;
    minexpire := 1;
        hayes := false;
      windows := true;
    gtversion := 18.00;
    biosvideo := false;
     usercaps := false;
       editor := '';
   usenetwork := true;
      defline := '';
   enhancelog := true;
 write_dorlog := true;
preevent_wait := 5;    {defaults to GT's 5 minute wait, added in 2.90b}
       filler := '';
    end; {with cnf do}
   Write( fcnf, cnf);
   close( fcnf );
   end
 else
   begin;
    Read( fcnf, cnf);  {read 1st, and only, record}
    Close( fcnf )
   end;

 if gtpathcnf_exist then            {v1.80 moves CNF file to TRCPATH}
 begin
   Assign( fcnf, gtpath + ncnf );
   {$i-} Erase( fcnf ); {$i+}
   WriteCNF;
 end;


 {validate cnf file to have reasonable values, just in case file is changed}
 {and no checks are made when using previously unused fields}
 if cnf.preevent_wait > 60 then
 begin
   beep; beep; beep;
   writeln('- ',cnf.preevent_wait,' min pre-event wait setting is more than 60 min.  Resetting to 5 min.');
   cnf.preevent_wait := 5;
   WriteCNF;
 end;

end; {ReadCNF}
(**************************************************************************)
PROCEDURE ReadDB( rec : integer );     {REC is actual door #}

var
  i,j,k : integer;

begin

  Seek( fdb, rec-1 );
  Read( fdb, db);  {read record #}

end; {ReadDB}
(**************************************************************************)
PROCEDURE WriteDB( rec : integer );    {REC is actual door #}

var
  i, j, k : integer;

begin

  Seek( fdb, rec-1);
  Write( fdb, db );

end; {WriteDB}
(**************************************************************************)
PROCEDURE ImportFiles;   {to update DoorWorks if files have changed}

label
  doover;

var
  fi, fo : text;
  gtd,x,y,z : string;
  c,i,j,k : integer;

begin

doover:

  writeln;
  writeln;
  writeln('Enter the full Path\Filename of the GTDDIR.BBS file whose door settings');
  writeln('you wish to import for node ',node,':');
  writeln('[Entering a blank response aborts the process and uses defaults]');
  write('=> ');
  readln( gtd );
  if not exist( gtd ) then
    exit;

  writeln;
  writeln;
  writeln('DoorWorks can restrict doors by baud rate.  You must give a default rate');
  writeln('for the doors you are importing now.  They may be customized later. ');
  writeln('You must use full numbers; ie: 300, 1200, 2400, 9600, 19200, 38400...');
  writeln;
  write('Enter the minimum baud rate to use doors (1200 recommended): ');
  readln(z);
  val(z, db.minbaud, k);
  writeln;

if not Openfdb then
  begin
  writeln(pname,': Unable to open ',trcpath,ndb);
  halt(1);
  end;

  { backup GTDDIR.BBS file }
if copyfile( gtd, 'gtddir.bak' ) = 0 then
  writeln('Backing up ',gtd,' to GTDDIR.BAK in current directory.')
else
begin
  writeln('Unable to backup ',gtd,'!  Aborting...');
  halt( 1 );
end;

Assign( fi, gtd );  { old GTDDIR.BBS to read in }
Reset( fi );

c := 0; {door/line counter}

db.conversion := '';
db.simul := true;
db.reqansi := false;
db.filedispbefore := '';
db.filedispafter := '';
while not eof( fi ) do
begin
 readln( fi, x );
 inc( c );
  {divide string x into its components}
  if wordcnt( x ) = 1 then
    db.minlevel := x[1]
  else if wordcnt( x ) = 2 then
  begin
    db.minlevel := x[1];
    y := ExtractWords(2,1,x);  { door description }
    db.doorname := copy(y, 2, length(y)-2);  { strip []'s }
  end
  else if wordcnt( x ) = 3 then
  begin
    db.minlevel := x[1];
    y := ExtractWords(2,1,x);  { door description }
    db.doorname := copy(y, 2, length(y)-2);  { strip []'s }
    if ExtractWords(3,1,x) = '&' then db.overlay := true else db.overlay := false;
  end;

  gotoxy(1,wherey);
  write('- Writing door #',c,', [',db.doorname,'], level ',db.minlevel,', Overlay=',db.overlay);
  clreol;
  WriteDB( c );
end; { while .. not eof }

close( fi );
closefdb;

end; {ImportFiles}

(**************************************************************************)
  FUNCTION GetInput : string;  { from questions in Setup }

    var
      answer : string;

  begin

    GotoXY(3,23);
    write('Now: ');
    readln(answer);

    cleartext(1,21,79,24,7,0);

    GetInput := answer;

  end; {GetInput}
(**************************************************************************)
PROCEDURE ConfigSetup;

label
  startagain;

var
  choice : char;
  temp : string;
  i,j,k  : integer;


  (**************************)
  PROCEDURE RedrawConfigSetup;  {redraws the screen after changing values}

  begin

  cleartext(1,4,79,25,7,0);

  writeat(2,5,7,0,'      Reg (n)ame:');
  writeat(2,6,7,0,'      (S)erial #:');
  writeat(2,7,7,0,'           (C)RC:');
  writeat(2,8,7,0,'    (F)irst name:');
  writeat(2,9,7,0,'     (L)ast name:');
 writeat(2,10,7,0,'    (G)T Version:');
 writeat(2,11,7,0,'    BIOS (V)ideo:');
 writeat(2,12,7,0,'Capi(t)alize all:');
 writeat(2,13,7,0,'    EnhanceL(O)G:');
 writeat(2,14,7,0,'    Kee(p) a LOG:');
 writeat(2,15,7,0,'Pre-Event (W)ait:');

  writeat(58,6,7,0,'(D)isplay:');
  writeat(58,7,7,0,'P(r)inter:');
  writeat(56,8,7,0,'Page (B)ell:');
  writeat(60,9,7,0,'(A)larm:');
  writeat(55,10,7,0,'(H)ayes 9600:');
  writeat(42,11,7,0,'Standard Secur(i)ty Level:');
  writeat(28,12,7,0,'(E)xtra min subtracted if event pending:');
  writeat(37,13,7,0,'(M)inimum time to pass to door:');
  writeat(31,14,7,0,'Ba(u)d to lock port (0 = not locked):');
  writeat(36,15,7,0,'Recognize networ(k) if present?:');

  writeat(3,17,14,0,'(Q)uit to main menu');

  textcolor( 15 );
  with cnf do
  begin
   GotoXY(20,5); cleartext(20,5,80,5,7,0); write(bbs);
   GotoXY(20,6); cleartext(20,6,23,6,7,0); write(serial);
   GotoXY(20,7); cleartext(20,7,55,7,7,0); write(crc);
   GotoXY(20,8); cleartext(20,8,59,8,7,0); write(sysfirst);
   GotoXY(20,9); cleartext(20,9,54,9,7,0); write(syslast);
   GotoXY(20,10); cleartext(20,10,41,10,7,0); write(gtversion:2:2);
   GotoXY(20,11); cleartext(20,11,23,11,7,0); write(biosvideo);
   GotoXY(20,12); cleartext(20,12,23,12,7,0); write(usercaps);
   GotoXY(20,13); cleartext(20,13,23,13,7,0); write(enhancelog);
   GotoXY(20,14); cleartext(20,14,23,14,7,0); write(write_dorlog);
   GotoXY(20,15); cleartext(20,15,23,15,7,0); write(preevent_wait,' min');
   GotoXY(69,6); cleartext(69,6,79,6,7,0); write(dis);
   GotoXY(69,7); cleartext(69,7,79,7,7,0); write(prn);
   GotoXY(69,8); cleartext(69,8,79,8,7,0); write(bel);
   GotoXY(69,9); cleartext(69,9,79,9,7,0); write(ala);
   GotoXY(69,10); cleartext(69,10,79,10,7,0); write(hayes);
   GotoXY(69,11); cleartext(69,11,79,11,7,0); write(sl);
   GotoXY(69,12); cleartext(69,12,79,12,7,0); write(kickoff,' min');
   GotoXY(69,13); cleartext(69,13,79,13,7,0); write(minexpire,' min');
   GotoXY(69,14); cleartext(69,14,79,14,7,0); write(lock);
   GotoXY(69,15); cleartext(69,15,79,15,7,0); write(usenetwork);
  end; {with cnf do}

  end; {RedrawConfigSetup}
(**************************)
begin

startagain:  RedrawConfigSetup;

GotoXY(3,21);
textcolor( 7 );
write('Enter ()''ed letter to change: ');
choice := Upcase(getkey);

GotoXY(3,25);
write('Enter the information.  A blank response will leave the field unchanged.');

GotoXY(3,22);
write('Was: ');

with cnf do
begin
  Case choice of
   'N' : begin
          write(bbs);
          temp := getinput;
          if temp <> '' then bbs := temp;
         end;
   'S' : begin
          write(serial);
          temp := getinput;
          if temp <> '' then val(temp, serial, k);
         end;
   'C' : begin
          write(crc);
          temp := Upper(getinput);
          if temp <> '' then crc := temp;
         end;
   'F' : begin
          write(sysfirst);
          temp := getinput;
          if temp <> '' then sysfirst := temp;
         end;
   'L' : begin
          write(syslast);
          temp := getinput;
          if temp <> '' then syslast := temp;
         end;
   'G' : begin
          write(gtversion:2:2);
          temp := getinput;
          if temp <> '' then val(temp, gtversion, k);
         end;
   'D' : dis := not dis;
   'R' : prn := not prn;
   'B' : bel := not bel;
   'A' : ala := not ala;
   'V' : biosvideo := not biosvideo;
   'H' : hayes := not hayes;
   'K' : usenetwork := not usenetwork;
   'O' : enhancelog := not enhancelog;
   'P' : write_dorlog := not write_dorlog;
   'W' : begin
          write(preevent_wait);
          temp := getinput;
          if temp <> '' then val(temp, preevent_wait, k);
         end;
   'I' : begin
          write(sl);
          temp := getinput;
          if temp <> '' then val(temp, sl, k);
         end;
   'E' : begin
          write(kickoff);
          temp := getinput;
          if temp <> '' then val(temp, kickoff, k);
         end;
   'M' : begin
          write(minexpire);
          temp := getinput;
          if temp <> '' then val(temp, minexpire, k);
         end;
   'U' : begin
          write(lock);
          temp := getinput;
          if temp <> '' then val(temp, lock, k);
         end;
   'T' : usercaps := not usercaps;

   'Q' : exit;           {exit this procedure}
  end; {Case choice}
end; {with cnf do}

goto startagain;

end; {ConfigSetup}
(**************************************************************************)
PROCEDURE RedrawDoorSetup;  {redraws the screen after changing values}

begin

cleartext(1,22,79,25,7,0);

textcolor(7);
GotoXY(53,5);  write('-[ Door ',dbpos,' / Node ',node,' ]-  ');
writeat(3,7,7,0,'          (D)oor name:');
writeat(3,8,7,0,'    (C)onversion type:');
writeat(3,9,7,0,'  Min. access (l)evel:');
writeat(3,10,7,0,'     Min. (b)aud rate:');
writeat(3,11,7,0,'      (O)verlay door?:');
writeat(3,12,7,0,'      (R)equire ANSI?:');
writeat(3,13,7,0,'(S)imultaneous nodes?:');
writeat(3,14,7,0,'(F)ile to show before:');
writeat(3,15,7,0,' File to show (a)fter:');

writeat(3,16,7,0,'(I)mport/update current GT files to DoorWorks');
writeat(3,17,7,0,'(Q)uit to main menu, (J)ump to a specific door number');

textcolor( 15 );
with db do
begin
  GotoXY(26,7);  cleartext(26,7,79,7,7,0);  write(doorname);
  GotoXY(26,8);  cleartext(26,8,79,8,7,0);  write(conversion);
  GotoXY(26,9);  cleartext(26,9,79,9,7,0);  write(minlevel);
  GotoXY(26,10);  cleartext(26,10,79,10,7,0);  write(minbaud);
  GotoXY(26,11);  cleartext(26,11,79,11,7,0);  write(overlay);
  GotoXY(26,12);  cleartext(26,12,79,12,7,0);  write(reqansi);
  GotoXY(26,13);  cleartext(26,13,79,13,7,0);  write(simul);
  GotoXY(26,14);  cleartext(26,14,79,14,7,0);  write(filedispbefore);
  GotoXY(26,15);  cleartext(26,15,79,15,7,0);  write(filedispafter);
end; {with db do}

end; {RedrawDoorSetup}
(**************************************************************************)
PROCEDURE DoorSetup;

label
  startagain;

var
  choice : char;
  temp   : string;
  i,j,k  : integer;
  itxt   : string;

begin

if not exist( trcpath + ndb ) then    {file is not there, make it}
  begin
   fillchar( db, sizeof(db), #0);
   Assign( fdb, trcpath+ndb );
   {$i-}
   Rewrite( fdb );
   {$i+}
   for i := 1 to 999 do
   begin
    with db do
      begin
         str(i,itxt);
          doorname := itxt;
        conversion := '';
          minlevel := 'z';
           overlay := FALSE;
             simul := TRUE;
           minbaud := 300;
           reqansi := FALSE;
    filedispbefore := '';
     filedispafter := '';
      end; {with db do}
   gotoxy(3, 5);
   write('- Initializing info for door ', i );
   Write( fdb, db);
   end; {for..do}
   closefdb;
   ImportFiles;
   cleartext(1,5,79,25,7,0);
  end; {begin..end if}

if not Openfdb then
  begin
  writeln(pname,': Unable to open ',trcpath,ndb);
  halt(1);
  end;

dbpos := 1;
readdb( dbpos );

startagain:  RedrawDoorSetup;

GotoXY(3,21);
textcolor( 7 );
write('Choose ()''ed letter, ''['' and '']'' change door numbers:');
choice := Upcase(getkey);

with db do
begin
  Case choice of
   'O' : overlay := not overlay;
   'R' : reqansi := not reqansi;
   'S' : simul := not simul;
   '[' : begin
          writedb( dbpos );
          if dbpos > 1 then
            dec(dbpos)
          else
            dbpos := 999;
          readdb( dbpos );
         end;
   ']' : begin
          writedb( dbpos );
          if (dbpos < 999) then
            inc(dbpos)
          else
            dbpos := 1;
          readdb( dbpos );
         end;
   'I' : begin
           cleartext(1,5,79,25,7,0);
           gotoxy(1,5);
           ImportFiles;
           cleartext(1,5,79,25,7,0);
           if not Openfdb then
           begin
             writeln(pname,' func DoorSetup, choice I: Unable to open ',trcpath,ndb);
             halt(1);
           end;
           dbpos := 1;
           readdb( dbpos );
         end;
   'Q' : exit;           {exit this procedure}
 end; {Case choice}

if pos(choice,'ORS[]IQ') <> 0 then goto startagain;  {if previous choice, goto startagain}

GotoXY(3,25);
write('Enter the information.  A blank response will leave the field unchanged.');

GotoXY(3,22);
write('Was: ');

Case choice of
   'J' : begin
          write(dbpos);
          temp := getinput;
          if temp <> '' then
          begin
             writedb(dbpos);
             val(temp, dbpos, k);
             if dbpos < 1 then dbpos := 1;
             if dbpos > 999 then dbpos := 999;
             readdb(dbpos);
          end;
         end;
   'D' : begin
          write(doorname);
          temp := getinput;
          if temp <> '' then doorname := temp;
         end;
   'L' : begin
          write(minlevel);
          temp := getinput;
          if temp <> '' then minlevel := temp[1];
         end;
   'B' : begin
          write(minbaud);
          temp := getinput;
          if temp <> '' then val(temp, minbaud, k);
         end;
   'S' : simul := not simul;
   'F' : begin
          write(filedispbefore);
          temp := Upper(getinput);
          if temp <> '' then filedispbefore := temp;
         end;
   'A' : begin
          write(filedispafter);
          temp := Upper(getinput);
          if temp <> '' then filedispafter := temp;
         end;
   'C' : begin
          write(conversion);
          temp := Upper(getinput);
          if temp <> '' then conversion := temp;
         end;
end; {Case choice}
end; {with db do}

goto startagain;

end; {DoorSetup}
(**************************************************************************)
PROCEDURE MainSetup;

label
  OVER;

var
  choice : char;

begin
writeln;
writeln('Initializing...');

{delay 5 seconds so initial screen can be viewed}
delay(3000);

OVER:

clrscr;
DrawOpening( pname, ver, ver_date, copyright_date, 14, 15 );

writeat(20,6,14,0,'(D)oor Configuration');
writeat(20,7,14,0,'(C)onfigure Main Settings');

writeat(20,9,14,0,'(Q)uit '+pname);

writeat(7,11,7,0,'Enter Choice: ');
GotoXY(21,11); {place the cursor correctly}

choice := Upcase(getkey);

  Case choice of
   'C' : begin
           ConfigSetup;
           cleartext(1,4,79,25,7,0);
           goto over;
         end;
   'D' : begin
           cleartext(1,4,79,25,7,0);
           DoorSetup;
           writedb( dbpos );
           closefdb;
           cleartext(1,9,79,25,7,0);
           goto over;
         end;
 end; {case}

if choice = 'Q' then
  begin
    writeln;
    writeln;
    CheckRegister;
    writeln;
    WriteCNF;
    halt;
  end
else
  goto over;

end; {MainSetup}

(**************************************************************************)
(*                    Communications routines                             *)
(**************************************************************************)
PROCEDURE CheckValidity( b : string255 ; vcode : integer );

begin

  Calculate( b );
  if vcode = 0 then exit;  { 0 means do not check for validation }
  if vcode <> crc_reg_5 then
   begin
    writeln;
    textcolor(12);
    writeln('Code is corrupted.  Inform author.  Aborting w/ errorlevel 2.');
    textcolor(7);
    { Skip communications routines if local }
    if (dte <> 0) then
     ClosePort(port);
    { Halt program w/ errorlevel 2 }
    halt( 2 );
   end;

end; {CheckValidity}
(**************************************************************************)
PROCEDURE SendStr( Buff : string255; sendtextfile : boolean );

label
 TRYAGAIN;

var
 LeftToSend : INTEGER;
 ReallySent : INTEGER;
 StartPos   : INTEGER;
 try : integer;
 crt : text;
 i : integer;

begin

    Assign( crt, '' );
    rewrite( crt );

    if not sendtextfile then
       if buff <> '' then writeln( crt, buff ); {don't print nulls to screen}

    Buff := Buff + crlf;
    for i := 1 to length(buff) do
    begin
     done := false;
     ch := buff[i];
     Repeat { Main loop }
         done := SendPort(Port, Ch);
     Until Done;
    end;

end; {SendStr}
(**************************************************************************)
{To announce the entering of DoorWorks}
PROCEDURE AnnounceIn(quick : boolean);

var
  x,y : integer;
  s : string255;
  serialtxt : string;
  de : string;
  xmin : string;
  fi : text;
  textln : string;

begin

  { Skip communications routines if local }
  if (dte = 0) then exit;

  textcolor(7);

  If OpenPort(port,dte,8,1,'N') then
    writeln('- Output to COM',port,': at ',dte,' baud:')
  else
   begin
    beep; beep; beep;
    textcolor(12);
    writeln('! Unable to open COM',port,': at ',dte,' baud!');
    textcolor( 7 );
    ClosePort(port);
    exit;
   end;

  SendStr( '', false );
  SendStr( '', false );

str(cnf.serial, serialtxt);

 {BEGIN REGISTRATION OUTPUT TO COM PORT}
 if not registered then
  begin
    s := hue[title]+#32+#254+#32+hue[14]+pname+#32+ver+hue[7]+' of '+hue[14]+ver_date;
    s := s + hue[7]+'; ['+hue[regcolor] + regtag + hue[7] + decrypt('eKmm~KK^[XKKY');
    SendStr( s, false ); {UNREGISTERED}
  end
  else
  begin
    s := hue[title] + #32 + #254 + #32 + hue[14] + pname + ' ' + ver + hue[7] + ' of '+hue[14]+ver_date+hue[7];
    s := s + ', ' + hue[regcolor] + regtag + hue[7] + ' [#'+hue[14]+serialtxt+hue[7]+']  ('+convtype+')';
    SendStr( s, false ); {REGISTERED}
  end;

  str( min, xmin );

  s := hue[7]+#32+#32+#32+decrypt('K')+#32+hue[14]+xmin+hue[7]+#32;
  s := s+decrypt('KKW')+hue[14]+#32+fname+hue[7]+'.';
  SendStr( s, false );

  SendStr( '', false );
  {END REGISTRATION OUTPUT TO COM PORT}


  if includetxt then
    begin
    textcolor( 7 );
    write('- Sending text file:  ',itxt);
    assign( fi, itxt );  {loc contains text file name since includetxt = true}
    {$i-}
    reset( fi );
    if ioresult <> 0 then
      begin
      beep; beep; beep;
      write(' * ERROR SENDING TEXT FILE! ');
      ClosePort(port);
      gotoxy(x,y);
      exit;
      end;
    {$i+}
    while not eof( fi ) do
      begin
      readln( fi, textln );
      sendstr( textln, true );
      write('.');
      end;
    close( fi );
    end;

  ClosePort(port);

  writeln;

end; {AnnounceIn}

(**************************************************************************)
(*           End of communications routines                               *)
(**************************************************************************)
(**************************************************************************)
Procedure ReadGTUSER;

var
  gtuser : text;
  gtuserln : string;

begin
  { Open and read GTUSER.BBS }
  Assign( gtuser, gtpath + 'gtuser.bbs');
  {$i-}
  Reset( gtuser );
  {$i+}
  If IoResult <> 0 then
    begin
     writeln('Cannot open ',gtpath,'GTUSER.BBS.  Exiting w/errorlevel 1');
     halt(1);
    end;

  Readln( gtuser, gtuserln );
  Close( gtuser );

  { Break down GTUSER.BBS }
  for i := 1 to 10 do
    param[i] := ExtractWords(i, 1, gtuserln);

  { Assign / process values from GTUSER.BBS }
  lvl := param[1];
  fname := param[2];
  lname := param[3];
  if lname = ';' then
    begin
     lname := '';
     full := fname;
    end
  else
     full := fname + #32 + lname;

  if cnf.usercaps then
    full := Upper(full);

  auth := param[4];

end; {ReadGTUSER}
(**************************************************************************)
PROCEDURE GetUserInfo;

const
  five_spaces = '     ';

var
  gotit : boolean;
  i : integer;
  junk : string;
  z : string;

begin

 ReadGTUSER;

 if param[5] = 'LOCAL' then
   BEGIN
     dte := 0;
     dce := 0;
     dce_not_avail := false;
   END
 else
  if pos(',', param[5]) = 0 then
   begin
    val(param[5], dte, k);
    dce := dte;
    dce_not_avail := true;
   end
  else
   BEGIN
    i := pos(',',param[5]);
    val( copy(param[5], 1, i-1), dte, k );
    val( copy(param[5], i+1, (length(param[5]) - i)), dce, k );
   END;

  if param[6] = 'ANSI' then
  {Assign ANSI colors, if ANSI is active}
    begin
      ansi := true;
      hue[1] := #27 + '[0;34m';
      hue[2] := #27 + '[0;32m';
      hue[3] := #27 + '[0;36m';
      hue[4] := #27 + '[0;31m';
      hue[5] := #27 + '[0;35m';
      hue[6] := #27 + '[0;33m';
      hue[7] := #27 + '[0m';
      hue[8] := #27 + '[1;30m';
      hue[9] := #27 + '[1;34m';
      hue[10] := #27 + '[1;32m';
      hue[11] := #27 + '[1;36m';
      hue[12] := #27 + '[1;31m';
      hue[13] := #27 + '[1;35m';
      hue[14] := #27 + '[1;33m';
      hue[15] := #27 + '[1;37m';
    end
   else
    begin
      ansi := false;
      hue[1] := '';
      hue[2] := '';
      hue[3] := '';
      hue[4] := '';
      hue[5] := '';
      hue[6] := '';
      hue[7] := '';
      hue[8] := '';
      hue[9] := '';
      hue[10] := '';
      hue[11] := '';
      hue[12] := '';
      hue[13] := '';
      hue[14] := '';
      hue[15] := '';
    end;

  { Time Calculations }
  val( param[8], timeleft, k );
  val( param[9], tillevent, k );

  { Get lesser time amount }
  if timeleft <= tillevent then maintimeleft := timeleft;
  if tillevent < timeleft then maintimeleft := tillevent - cnf.preevent_wait; {subtract pre-event wait}

  { Calculate time left }
  logontime := param[10];
  i := pos(':', param[10]);
  val( copy(param[10], 1, i-1), lhour, k );
  val( copy(param[10], i+1, (length(param[10]) - i)), lmin, k);
  if lhour = 24 then lhour := 0;

  GetTime( hour, minute, sec, sec100 );

  if lhour > hour then  {ie: rolled over midnight}
  begin  {calc part before midnight, then after midnight}
    min := ( maintimeleft - ( (24*60) - (lhour*60 + lmin ) ) );
    min := ( min - ((hour*60) + minute) );
  end
  else
    min := (maintimeleft - (((hour * 60) + minute) - ((lhour * 60) + lmin)));

  if tillevent < timeleft then  {event is pending}
    min := min - cnf.kickoff;

  if min <= 1 then min := cnf.minexpire;

 { find logon time in minutes (PCB14) }
   logontimeinmin := (lhour*60) + lmin;

 { Find time on so far }
   if lhour > hour then {rolled over midnight}
      timeon := (1440 - logontimeinmin) + ((hour*60)+minute)
      {1440 is midnight in minutes}       {any mintues after 00:00 is current time in minutes}
   else
      timeon := ((hour*60)+minute) - logontimeinmin;

  { set logontime and currenttime }
  if copy(logontime, 1, 2) = '24' then
    logontime := '00:' + copy(logontime, 4, 2);
  if logontime[2] = ':' then
    logontime := '0' + logontime;

  { fix appearance of showlogontime }
    if lhour > 12 then
      begin
        lhour := lhour - 12;
        pm := 'pm';
      end
    else
      pm := 'am';

    Str(lhour, t);
    { pad lhour 1 spc to lt if < 10 }
      if lhour < 10 then
        t := ' ' + t;
    Str(lmin, u);
    { fix 1 digit minute possibility }
    if lmin < 10 then
      u := '0' + u;
    showlogontime := t + '.' + u + ' ' + pm;

  { fix appearance of showcurrenttime }
    if hour > 12 then
      begin
        hour := hour - 12;
        pm := 'pm';
      end
    else
      pm := 'am';

    Str(hour, t);
    { pad to the left if hour < 10 }
     if hour < 10 then
       t := ' ' + t;
    Str(minute, u);
    { fix 1 digit minute possibility }
     if minute < 10 then
       u := '0' + u;
    showcurrenttime := t + '.' + u + ' ' + pm;
    currenttime := t + ':' + u;

textcolor(7);

{ Open user file }
if not Openfuser then
 begin
  writeln(pname,': Unable to open _USER.CTL.  Exiting with errorlevel 1.');
  halt( 1 );
 end;

{ Find user in file first using INDX }

  numberofusers := filesize(fuser)-1;
  sk := ReadINDX;
  if sk > filesize(fuser) then sk := 0; {sk could be out of bounds if user file was reorganized}
  gotit := false;

  if sk <> 0 then { INDX was successful }
   begin
    write( '- QuickSearching for ', full,'...');
    seek( fuser, sk-1 );
    read( fuser, user );
    if Pos(Upper(full), Upper(user.whole)) <> 0 then
     begin
      writeln('  Found.');
      if registered then
        AnnounceIn(true);  {true, meaning abbreviated version, quick index}
      gotit := true;
      usercount := sk;
     end
    else
     writeln(' Not found.  Trying standard search.');
   end;

  {Then, default to normal search}
  if gotit = false then
  begin
   write( '- Standard Search for ',full,'.  Please wait...');
   reset( fuser );
   usercount := 0;
   repeat
    read( fuser, user );
    inc(usercount);
    gotit := Pos(Upper(full), Upper(user.whole)) <> 0
   until eof( fuser ) or gotit;
   if gotit = false then
   begin
       writeln;
       beep; beep; beep;
       textcolor( 12 );
       Writeln('! Cannot find ''',full,''' in ',gtpath,'_USER.CTL');
       Writeln('! Exiting with errorlevel 1.');
       textcolor(7);
       halt(1);
   end
   else  {gotit is true}
   begin
       writeln('  Found.');
       WriteINDX(usercount);
       AnnounceIn(false); {longer announcement}
   end;
  end;


Closefuser;

{fix name}
full := Strip('R', #0, user.whole);
if cnf.usercaps then
  full := Upper(full);

{Process phone number}
phone := Strip('B',' ',user.telephone);
phone := Strip('A',#0,phone);
if length( phone ) = 7 then
 insert( '-', phone, 4)
else
 if length( phone ) = 10 then
 begin
   insert( '-', phone, 4);
   insert( '-', phone, 8);
 end; {if length(phone)..}

  { Date Calculations }
  z := user.lastdate;
  ldate := copy(z,5,2) + '/' + copy(z,7,2) + '/' + copy(z,1,4);

{Show user info on screen}
textcolor(7);
write('- Time now: ');
textcolor(14);
write(showcurrenttime,five_spaces,maintimeleft);
textcolor(7);
writeln(' minute(s) allowed for this call');

write('- Logon at: ');
textcolor(14);
write(showlogontime,'   - ',timeon);
textcolor(7);
writeln(' minute(s) used');

for i := 1 to 22 do
  write(#32);

write(#32,'=',#32);
textcolor(14);
write(min);
textcolor(7);
writeln(' minute(s) left in door (after adjustments)');

writeln;
write('- Writing ');
textcolor(14);
write(convtype);
textcolor(7);
writeln(' files for ',full);
writeln('  ', chopnull(user.home), '  ', phone, '  Last on ',ldate);

end; {GetUserInfo}
(**************************************************************************)
{$I DWORKS3.PAS}    {Door Conversion Routines}
(**************************************************************************)
Procedure WriteTimeText;

var
  ftimetext : text;
  h1,m1,s1,s1100 : word;

begin

  Assign( ftimetext, trcpath + ntimetext );
  {$i-} Rewrite( ftimetext ); {$i+}
  Gettime( h1, m1, s1, s1100 );
  Writeln( ftimetext, h1 );
  Writeln( ftimetext, m1 );
  Close( ftimetext );

end;
(**************************************************************************)
Function ReadTimeText ( doornum : integer ) : string;

var
  ftimetext : text;
  tersetime, tersedate : string[5];
  tin : word;
  hour0, minute0 : string[3];
  h0, m0 : word;
  e : integer;
  xdoornum : string[5];
  year,
  month,
  day,
  dayofweek : word;
  io : word;

     (*******************)
      Procedure TimeFunc;

      var
        h,m,s,y,mth,d : string;

      begin

        GetTime( hour, minute, sec, sec100 );
          str( hour, h );
          str( minute, m );

          if length(h) < 2 then
            h := ' ' + h;

          if length(m) < 2 then
            m := '0' + m;

          tersetime := h + ':' + m;

        GetDate( year, month, day, dayofweek );
          str( month, mth );
          str( day, d );

          if length(mth) < 2 then
            mth := ' ' + mth;
          if length(d) < 2 then
            d := '0' + d;

          tersedate := mth + '-' + d;

      end; {TimeFunc}
     (***************)

begin

  TimeFunc;

  Assign( ftimetext, trcpath + ntimetext );
  {$i-} Reset( ftimetext ); io := IoResult; {$i+}
  if io <> 0 then
  begin
    writeln;
    writeln('    Unable to find ', trcpath, ntimetext, '; unable to log out door ', doornum );
    halt(1);
  end;
  readln( ftimetext, hour0 );
  readln( ftimetext, minute0 );
  Close( ftimetext );
  Erase( ftimetext );

  val( hour0, h0, e );
  val( minute0, m0, e );

  if h0 > hour then  {rolled over to midnight}
  begin
    tin := (24*60) - (h0*60 + m0);      {1440=midnight in minutes (24*60)}
    tin := tin + ((hour*60) + minute) ;
  end
  else
    tin := ((hour*60)+minute)-((h0*60)+m0);

  if tin <> 0 then
     str( tin , time_in_door)
  else
     time_in_door := '1';

  str( doornum, xdoornum);

  ReadTimeText := tersedate + ' ' + tersetime + '   ; [' + pname + ']:  Door #' + xdoornum + ', ' + time_in_door +  ' min';

  writeln;
  writeln('- Logging out ',full, ' on ', tersedate, ' at ', tersetime, '.');
  writeln('- ',time_in_door,' minute(s) in door #', doornum);
  writeln;

end; {ReadTimeText}
(**************************************************************************)
Procedure ResetDoorUsageFiles;

const
  dworkdorbak = 'dworkdor.bak';

var
 fmisc : file;

begin
            if copyfile( trcpath+nlog, trcpath+dworkdorbak ) = 0 then
              writeln('- Backing up ',trcpath+nlog,' to ',trcpath+dworkdorbak)
            else
            begin
             writeln('- Unable to backup ',trcpath+nlog,'!  File not found.');
             writeln('  You must have recently used this RESET option.');
             exit;
            end;


            writeln('- Deleting door usage files ...');
            if exist( trcpath + nlog ) then
            begin
             writeln('  ',trcpath + nlog);
             Assign( fmisc, trcpath + nlog );
                {$i-} Erase( fmisc ); {$i+}
            end;

            if exist( trcpath + ntimetext ) then
            begin
              writeln('  ',trcpath+ntimetext);
              Assign( fmisc, trcpath + ntimetext );
                {$i-} Erase( fmisc ); {$i+}
            end;

end; {ResetDoorUsageFiles}
(**************************************************************************)
Procedure DoorLog( op : char );  {if going OUT, must be called
                                  after ReadTimeText}

var
  h,m,s,s100,y,mth,d,dow : word;
  t1 : string;
  ioerr : word;
  ftext : text;


begin

   if not cnf.write_dorlog then exit;

   {added in 2.20 to move DWORKDOR.LOG from GTPATH to TRCPATH}
   if exist( gtpath + nlog ) then
   begin
     writeln('- Door log file found in ',gtpath,'.  Moving to ',trcpath,'.');
     if ( copyfile( gtpath+nlog, trcpath+nlog ) <> 0 ) then
     begin
       beep; beep; beep;
       writeln('- Cannot copy ',gtpath,nlog, ' to ',trcpath,nlog);
       writeln('- Exiting with errorlevel 1, move this file manually.');
       beep; beep; beep;
       halt(1);
     end;
     assign( ftext, gtpath+nlog );
     {$I-} erase( ftext ); {$I+}
     if IOResult <> 0 then
     begin
       beep; beep; beep;
       writeln('- Cannot erase ',gtpath,nlog,'.');
       writeln('- Exiting with errorlevel 1, delete this file manually.');
       beep; beep; beep;
       halt(1);
     end;
   end;


   GetDate( y, mth, d, dow );
   GetTime( h, m, s, s100 );

   Assign( flog, trcpath + nlog);
   {$i-} Reset( flog );
         ioerr := ioresult;
   {$i+}
   if ioerr <> 0 then
   begin
     {$i-} Rewrite( flog ); {i$+}
     close( flog );
   end;

   Assign( flog, trcpath + nlog );
   {$i-} Append( flog ); {$i+}

   if upcase(op) = 'I' then
     writeln( flog,'I',#32,'I',#32,mth,#32,d,#32,y,#32,dow,#32,h,#32,m,#32,s,#32,full,#32,chr(user.level))
   else if upcase(op) = 'O' then
     writeln( flog,dnum,#32,time_in_door,#32,mth,#32,d,#32,y,#32,dow,#32,h,#32,m,#32,s,#32,full,#32,lvl);

   Close( flog );

end; {DoorLog}
(**************************************************************************)
Procedure CheckConvType;

begin

    {Command Line must have options in this order.  [] indicates option}
    {  or parameter may be omitted.                                    }
    {                                                                  }
    {  DWORKS Conversion_Type [Target_directory] [/I:textfile_name]    }


    ctype := Upper(ParamStr(1));
    loc := Upper(ParamStr(2));

    if pos('/I:',Upper(Paramstr(3))) <> 0 then
    begin
      includetxt := true;
      itxt := copy(Upper(Paramstr(3)),4,length(Paramstr(3))-3);
    end;

   if pos('/I:', loc ) <> 0 then
    begin
      includetxt := true;
      itxt := copy( loc,4,length(loc)-3 );
      loc := '';
    end
   else
    begin
      includetxt := false;
      itxt := '';
    end;

   if (loc[length(loc)] <> '\') and (loc <> '') then
     loc := loc + '\';


  if ctype = 'CONFIG' then
    MainSetup
  else
   begin

   { be sure users are using v15 }
   if cnf.gtversion < 19.0 then
    begin
      writeln('DoorWorks ',ver,' does not support versions of GT Power below 19.00');
      writeln;
      writeln('If this is an error, run DWORKS CONFIG, choose (C) for configuration');
      writeln('and change the version of GT you are using to be correct.');
      halt;
    end;


    if ctype = 'GAP' then
            convtype := 'GAP Communications'
    else if ctype = 'QBBS' then
            convtype := 'QuickBBS'
    else if ctype = 'RBBS' then
            convtype := 'RBBS'
    else if ctype = 'UI' then
            convtype := 'Milton Gameworks'
    else if ctype = 'WC' then
            convtype := 'Wildcat!'
    else if ctype = 'DRWY' then
            convtype := 'DOORWAY'
    else if ctype = '14' then
            convtype := 'PCBoard v14.x'
    else if ctype = '12' then
            convtype := 'PCBoard v12.1'
    else if ctype = 'OO' then
            convtype := 'Operation Overkill II'
    else if ctype = 'WWIVGATE' then
            convtype := 'Gateway to WWIV'
    else if ctype = 'QBBSGATE' then
            convtype := 'Gateway to QuickBBS'
    else if ctype = 'GENERIC' then
            convtype := 'CKIT GENERIC.SYS'
    else if ctype = 'RA' then
            convtype := 'RemoteAccess v1.00'
    else if ctype = 'SF' then
            convtype := 'SpitFire'
    else if ctype = 'WWIV' then
            convtype := 'WWIV'
    else if ctype = 'SRDOOR' then
            convtype := 'The Realms DOORFILE.SR'
    else if copy(ctype,1,5) = '/OUT:' then
            convtype := 'Door Logout'
    else if ctype = 'LOGIN' then
            convtype := 'Door Login'
    else if copy(ctype,1,11) = '/DOORGRAPH:' then
            convtype := 'Door Graph'
    else if copy(ctype,1,4) = '/TOP' then
            convtype := 'Top Door Graph'
    else if ctype = 'RESET' then
            convtype := 'Reset Door Usage Files'
    else
         InvalidCommandLine(pname,ver,divider);
   end;  {if..then}

end; {CheckConvType}
(**************************************************************************)
PROCEDURE Convert;

begin

         if ctype = 'GAP' then
            GAP
    else if ctype = 'QBBS' then
            QBBS( false )
    else if ctype = 'RBBS' then
            QBBS( false )
    else if ctype = 'UI' then
            UI
    else if ctype = 'WC' then
            WC
    else if ctype = 'DRWY' then
            DRWY
    else if ctype = '14' then
            PCB14
    else if ctype = '12' then
            PCB12
    else if ctype = 'OO' then
            OO
    else if ctype = 'WWIVGATE' then
            WWIVGATE
    else if ctype = 'QBBSGATE' then
            QBBSGATE
    else if ctype = 'GENERIC' then
            GENERIC
    else if ctype = 'RA' then
           begin
            QBBS( true );
            RA100;
           end
    else if ctype = 'SF' then
            SF
    else if ctype = 'WWIV' then
            WWIV
    else if ctype = 'SRDOOR' then        {Solar Realms, Barron Realms, etc added}
            SRDOOR;                      {10/06/93 req by Stephen Schauer for v2.91b}

    WriteTimeText;

end; {Convert}
(**************************************************************************)
{ Main Code }

BEGIN

dbpos := 1;    { position in doors database }

clrscr;

{replace standard drawing of opening screen with new UNCRUNCH routine v2.90beta}
UnCrunch (DWSCREEN,ScreenAddr[ (1*2) + (1*160) -162],DWSCREEN_LENGTH);
gotoxy(14,2);
textcolor(14);
writeln('v',ver, ' of ',ver_date);
gotoxy(1,DWSCREEN_DEPTH+1);

{Clear keyboard buffer}
MemW[$0000:$041C] := MemW[$0000:$041A];

{put command line into variable}
for i := 1 to paramcount do
  cmdline := cmdline + paramstr(i) + #32;

Initialize;

ReadCNF;

  if cnf.biosvideo then DirectVideo := FALSE else DirectVideo := TRUE;

CheckRegister;
writeln;  {to separate opening screen from rest of output}

CheckConvType;  {check validity of command line, else show help screen
                 and halt}

if copy(ctype, 1, 5) = '/OUT:' then
         begin
              ReadGTUSER;
              val( copy(ctype, 6, length(ctype)-5), dnum, e );
              ln := ReadTimeText( dnum );
              if logpath = '' then
                  Assign( f, gtpath + 'GT.LOG' )
                else
                  Assign( f, logpath + 'GT.LOG' );
              if cnf.enhancelog then
              begin
                Append( f );
                writeln( f, ln);
                Close( f );
              end;
              DoorLog('O');
         end
(*
else if copy(ctype,1,4) = '/IN:' then
         begin
              val( copy(ctype, 6, length(ctype)-5), dnum, e );
              ReadDB( dnum );
         end
*)
else if ctype = 'LOGIN' then
         begin
            writeln('- Logging user into door...');
            DoorLog('I');
         end
else if ctype = 'RESET' then
         begin
            ResetDoorUsageFiles;
         end
else if copy(ctype,1,11) = '/DOORGRAPH:' then
         begin
              textcolor(7);
              writeln('- Creating Complete Door Usage Report');
              bulletin_number := copy(ctype, 12, length(ctype)-11);

              writeln('- Parsing GTDDIR.BBS door information file');
              ParseGTDDIR;

              writeln('- Parsing DWORKDOR.LOG and compiling door information');
              ParseDWORKLOG;

              writeln('- Ranking doors in order of popularity (total minutes used)');
              Sort( time_in_door_ARRAY, c );

              writeln('- Writing ASCII bulletin:  ', bullpath, bulletin_number );
              WriteReport('B', bulletin_number );  {BBS file}
              writeln('- Writing ANSI bulletin:   ', bullpath, bulletin_number, cbs );
              WriteReport('C', bulletin_number );  {CBS file}
         end
else if copy(ctype,1,4) = '/TOP' then
         begin
              top_number_str := copy( ctype, 5, pos(':',ctype)-5 );
              val( top_number_str, top_number, e);

              textcolor(7);
              writeln('- Creating Top ',top_number_str,' Door Usage Report');
              bulletin_number := copy( ctype, pos(':',ctype)+1, length(ctype)-(pos(':',ctype)) );

              writeln('- Parsing GTDDIR.BBS door information file');
              ParseGTDDIR;

              writeln('- Parsing DWORKDOR.LOG and compiling door information');
              ParseDWORKLOG;

              writeln('- Ranking doors in order of popularity (total minutes used)');
              Sort( time_in_door_ARRAY, c );

              writeln('- Writing ASCII bulletin:  ', bullpath, bulletin_number );
              WriteTOPReport('B', bulletin_number );  {BBS file}
              writeln('- Writing ANSI bulletin:   ', bullpath, bulletin_number, cbs );
              WriteTOPReport('C', bulletin_number );  {CBS file}
         end
else
         begin
          GetUserInfo;
          Convert;
          DoorLog( 'I' );  {obviously, we are logging in if it gets this far}
          textcolor( 7 );
         end;

DrawClosing( 1, 14 );

END.
