(* Released into the public domain April 1, 1995.  No warranties, use at *)
(* your own risk.  Copyright Jason Cory Wright 1995                      *)
(***************************************************************************)
PROCEDURE PRealToBReal(PasReal: real; var B: BReal);
var
  PasArray: array [0 .. 5] of byte absolute PasReal;
  BasArray: array [0 .. 3] of byte absolute B;
begin
  move(PasArray[3],BasArray[0],3);
  BasArray[3]:=PasArray[0];
  end;
(****************************************************************************)
PROCEDURE crc80_calc;

   BEGIN
      inline($B9/>$08);     { mov cx,8    }
      inline($A1/crc_input);    { mov ax,crc_input  }
      inline($D0/$D8);      {  u12: rcr al,1    }
      inline($8B/$1E/crc_reg_5);  { mov     bx,crc_reg_5  }
      inline($D1/$DB);      { rcr     bx,1    }
      inline($89/$1E/crc_reg_5);  { mov     crc_reg_5,bx  }
      inline($8B/$1E/crc_reg_4);  { mov     bx,crc_reg_4  }
      inline($D1/$DB);      { rcr     bx,1    }
      inline($89/$1E/crc_reg_4);  { mov     crc_reg_4,bx  }
      inline($8B/$1E/crc_reg_3);  { mov     bx,crc_reg_3  }
      inline($D1/$DB);      { rcr     bx,1    }
      inline($89/$1E/crc_reg_3);  { mov     crc_reg_3,bx  }
      inline($8B/$1E/crc_reg_2);  { mov     bx,crc_reg_2  }
      inline($D1/$DB);      { rcr     bx,1    }
      inline($89/$1E/crc_reg_2);  { mov     crc_reg_2,bx  }
      inline($8B/$1E/crc_reg_1);  { mov     bx,crc_reg_1  }
      inline($D1/$DB);      { rcr     bx,1    }
      inline($89/$1E/crc_reg_1);  { mov     crc_reg_1,bx  }
      inline($73/$03);      { jnc u22   }
      inline($EB/$06/$90);    { jmp u33   }
      inline($E2/$C5);      {  u22: loop  u12             }
      inline($EB/$3F/$90);    { jmp u44   }
      inline($8B/$1E/crc_reg_1);  {  u33: mov     bx,crc_reg_1  }
      inline($81/$F3/$B25D);    { xor bx,8321h  }
      inline($89/$1E/crc_reg_1);  { mov     crc_reg_1,bx  }
      inline($8B/$1E/crc_reg_2);  { mov     bx,crc_reg_2  }
      inline($81/$F3/$A84F);    { xor bx,5DB6h  }
      inline($89/$1E/crc_reg_2);  { mov     crc_reg_2,bx  }
      inline($8B/$1E/crc_reg_3);  { mov     bx,crc_reg_3  }
      inline($81/$F3/$C64C);    { xor bx,2141h  }
      inline($89/$1E/crc_reg_3);  { mov     crc_reg_3,bx  }
      inline($8B/$1E/crc_reg_4);  { mov     bx,crc_reg_4  }
      inline($81/$F3/$9E7D);    { xor bx,7EA9h  }
      inline($89/$1E/crc_reg_4);  { mov     crc_reg_4,bx  }
      inline($8B/$1E/crc_reg_5);  { mov     bx,crc_reg_5  }
      inline($81/$F3/$09BB);    { xor bx,1D54h  }
      inline($89/$1E/crc_reg_5);  { mov     crc_reg_5,bx  }
      inline($EB/$BD);      { jmp     u22   }
      inline($90);      {  u44: nop                     }
   END;
(****************************************************************************)
   FUNCTION
      Hex( h : INTEGER ) : STRING4;
   VAR
      ans  : STRING4;
      hh   : INTEGER;
      dh   : INTEGER;
      i    : INTEGER;
   BEGIN
      ans:='    ';
      hh:=h;
      FOR i:=4 DOWNTO 1 DO BEGIN
         dh:=hh AND $000F;
         hh:=hh shr 4;
         IF dh<10 THEN
            ans[i]:=CHR(ORD('0')+dh)
         ELSE
            ans[i]:=CHR(ORD('A')+dh-10);
      END;
      Hex:=ans;
   END;
(****************************************************************************)
   PROCEDURE
       calculate(VAR s : string255);
   VAR
       j    : INTEGER;
   BEGIN
       crc_reg_1:=0;
       crc_reg_2:=0;
       crc_reg_3:=0;
       crc_reg_4:=0;
       crc_reg_5:=0;
       FOR j:=1 TO Length(s) DO BEGIN
           crc_input:=ORD(s[j])+16;
           crc80_calc;
       END;
       crc_input:=0;
       FOR j:=1 TO 10 DO
           crc80_calc;
   END;
(**************************************************************************)
Function ReadINDX : longint;

var
   fin : text;
   ndx : NDXREC;
  indx : string;
    st : string;
     e : integer;

begin

  ReadINDX := 0;

  if not registered then exit;

  indx := trcpath + indxfilename;

  if not ( exist(indx) ) then {File not found! Make it.}
   begin
     {Creating new dworks.ndx file}
     Assign( fin, indx );
     rewrite( fin );
     ndx.rec := 0;
     writeln( fin, '0');
     ReadINDX := ndx.rec;
     close( fin );
   end
  else {file found.. read it!}
   begin
     {$I-}
     Assign( fin, indx );
     reset( fin );
     readln( fin, st);
     {$I+}
     val( st, ndx.rec, e);
     if (e=0) then
       ReadINDX := ndx.rec
     else
       ReadINDX := 0;
   end;

END; {ReadINDX}
(**************************************************************************)
Procedure WriteINDX( c : longint );

var
  fout : text;
   ndx : NDXREC;
  indx : string;

begin

  if not registered then exit;

  indx := trcpath + indxfilename;

  Assign( fout, indx );
  {$i-}
  Rewrite( fout );
  {$i+}

  if c > 0 then
  begin
    writeln(fout, c);
    ndx.rec := c;
  end
  else
  begin
    writeln(fout, '0');
    ndx.rec := 0;
  end;

  close( fout );  {close DWORKS.NDX}

END; {WriteIndx}
(****************************************************************************)
function openfuser:boolean;
  var
   a,b,c,hh,mm,ss,s1:word;
   tmp:integer;
   try,ok:boolean;
   srch:searchrec;
   pr:registers;

  begin

  if (lanpath <> '') and (cnf.usenetwork) then
   BEGIN
    filemode:=dnrw;
    try:=true;
    ok:=false;
        b:=0;
        gettime(hh,mm,a,s1);
        assign(fuser,lanpath + '_user.ctl');
        reset(fuser);
        while try do with pr do
          begin
            ah:=$5C;
            al:=0;
            BX:=filerec(fuser).handle;
            cx:=0;
            dx:=0;
            si:=0;
            di:=sizeof(GT19UserRecord);
            msdos(pr);
            try:= (flags and 1) <> 0;
            if try then
              begin
                c:=a;
                while c=a do gettime(hh,mm,a,s1);
                inc(b);
                try:= b < 30;
              end
            else
              ok:=true;
          end;
     if not ok then writeln('DWORKS: Unable to lock ',lanpath,'_user.ctl!');
    openfuser:=ok;
    END
  ELSE
    BEGIN
      Assign( fuser, gtpath + '_user.ctl' );
      reset( fuser );
    END;
end;
(***************************************************************************)
procedure closefuser;
  var
    pr:registers;
  begin
  if (lanpath <> '') and (cnf.usenetwork) then
  BEGIN
    filemode:=dnrw;
    with pr do
      begin
            ah:=$5C;
            al:=1;
            BX:=filerec(fuser).handle;
            cx:=0;
            dx:=0;
            si:=0;
            di:=sizeof(GT19UserRecord);
            msdos(pr);
            close(fuser);
      end;
    if doserror <> 0 then
      writeln('DWORKS: Error unlocking ',lanpath,'_USER.CTL - Doserror=',doserror);
  END
  else
   close( fuser );

end;
(***************************************************************************)
function openfdb:boolean;
  var
   a,b,c,hh,mm,ss,s1:word;
   tmp:integer;
   try,ok:boolean;
   srch:searchrec;
   pr:registers;

  begin

  if lanpath <> '' then
    BEGIN
    filemode:=dnrw;
    try:=true;
    ok:=false;
        b:=0;
        gettime(hh,mm,a,s1);
        assign(fdb, trcpath + ndb);
        reset( fdb );
        while try do with pr do
          begin
            ah:=$5C;
            al:=0;
            BX:=filerec(fdb).handle;
            cx:=0;
            dx:=0;
            si:=0;
            di:=sizeof(dbrec);
            msdos(pr);
            try:= (flags and 1) <> 0;
            if try then
              begin
                c:=a;
                while c=a do gettime(hh,mm,a,s1);
                inc(b);
                try:= b < 30;
              end
            else
              ok:=true;
          end;
     if not ok then writeln('DWORKS: Unable to lock ', trcpath, ndb );
    openfdb := ok;
    END
  ELSE
    BEGIN
      Assign( fdb, trcpath + ndb );
      {$I-} Reset( fdb ); {$I+}
      if IOResult <> 0 then
        {$I-} Rewrite( fdb ); {$I+}
    END;
end;
(***************************************************************************)
procedure closefdb;
  var
    pr:registers;
  begin
  if lanpath <> '' then
  BEGIN
    filemode:=dnrw;
    with pr do
      begin
            ah:=$5C;
            al:=1;
            BX:=filerec(fdb).handle;
            cx:=0;
            dx:=0;
            si:=0;
            di:=sizeof(dbrec);
            msdos(pr);
            close(fdb);
      end;
    if doserror <> 0 then
      writeln('DWORKS: Error unlocking ',trcpath,ndb,' - Doserror=',doserror);
  END
  else
   close( fdb );

end;
(***************************************************************************)
