(* Released into the public domain April 1, 1995.  No warranties, use at *)
(* your own risk.  Copyright Jason Cory Wright 1995                      *)
(**************************************************************************)
PROCEDURE SRDOOR; {used by Solar Realms, Barron Realms, AC6; added 10/06/1993
                   for inclusion in v2.91b}

const
  doorfile = 'DOORFILE.SR';

var
  filename : string;
  fout : text;
  pw : string;
  z : string;

begin

Assign(fout, loc + doorfile);
Rewrite( fout );

writeln(fout, full );                   { Line 1 - full name or handle }
if ansi then
 begin
  writeln(fout, '1' );
  writeln(fout, '1' );
 end
else
 begin
  writeln(fout, '0' );                  { Line 2 - 1=ANSI, 0=no ANSI, -1=don't know (not impl) }
  writeln(fout, '-1');                  { Line 3 - IBM Graphics, same designation as line 2 }
 end;

writeln(fout, user.pgln );              { Line 4 - user's page length - standard is 24 for DWorks,}
                                        { SRDOOR file spec's default is 25 }

writeln( fout, dce );                   { Line 5 - Baud rate }
if dte = 0 then                         { Line 6 - com port, # only, 0=local }
 writeln( fout, '0' )
else
 writeln( fout, com);

writeln(fout, min );                    { Line 7 - minutes left, -1=unlimited, not impl }
writeln(fout, full );                   { Line 8 - full name, real (no handle) same as Line 1 }

close( fout );

end; {SRDOOR}
(**************************************************************************)
PROCEDURE GENERIC;

const
  doorfile = 'GENERIC.SYS';

var
  filename : string;
  fout : text;
  pw : string;
  z : string;

begin

Assign(fout, loc + doorfile);
Rewrite( fout );

writeln( fout, cnf.sysfirst );      {Line 1 - Sysop's first name}
if dte = 0 then
  writeln( fout, 'COM0:' )
else
  writeln( fout, 'COM', com, ':');  {Line 2 - Com port - COM0: = LOCAL}
writeln( fout, min );               {Line 3 - Minutes left}

close( fout );

end; {GENERIC}
(**************************************************************************)
PROCEDURE GAP;

const
  doorfile = 'DOOR.SYS';

var
  filename : string;
  fout : text;
  pw : string;
  z : string;

begin

Assign(fout, loc + doorfile);
Rewrite( fout );

if dte = 0 then
 writeln( fout, 'COM0:' )
else
 writeln( fout, 'COM', com, ':');  {Line 1 - Com port - COM0: = LOCAL}

writeln( fout, dce );          { 2 - Baud rate }
writeln(fout,'8');                  { 3 - parity, always 8 }
writeln(fout, node );               { 4 - node number }
if cnf.lock <> 0 then
   writeln(fout, cnf.lock )         { 5 - DTE rate.  Actual rate to use}
 else
   writeln(fout, dte );
if cnf.dis then writeln(fout,'Y') else writeln(fout,'N');  { 6 - screen display }
if cnf.prn then writeln(fout,'Y') else writeln(fout,'N');  { 7 - printer toggle }
if cnf.bel then writeln(fout,'Y') else writeln(fout,'N');  { 8 - bell }
if cnf.ala then writeln(fout,'Y') else writeln(fout,'N');  { 9 - alarm }
writeln(fout, full );         { 10 - full name }
writeln(fout, chopnull(user.home) );    { 11 - hometown  }
writeln(fout, phone );        { 12 - home phone}
writeln(fout, phone );        { 13 - work phone}  {lines 12 and 13 are same}
writeln(fout, chopnull(user.password) ); { 14 - user password }
writeln(fout, cnf.sl );       { 15 - security level }
writeln(fout, user.timeson ); { 16 - times on }
writeln(fout, ldate );        { 17 - last date on }
writeln(fout, min * 60 );     { 18 - seconds left }
writeln(fout, min );          { 19 - minutes left }
if ansi then
  writeln(fout, 'GR' )
else
  writeln(fout, 'NG' );       { 20 - GR=graphics, NG=no graphics }
writeln(fout, user.pgln );    { 21 - user's page length - standard is 24 }
if user.expert then
  writeln(fout, 'Y' )
else
  writeln(fout, 'N' );        { 22 - Expert mode flag }
writeln(fout, '1' );          { 23 - confs registered in - dummy arg. '1,2,3,4' }
writeln(fout, '1' );          { 24 - conf exited to DOOR from - dummy }
writeln(fout,'12/25/99');     { 25 - user expiration date - dummy }
writeln(fout, userrec );      { 26 - user file record number }
writeln(fout, 'N' );          { 27 - default protocol 'N'=none }
writeln(fout, user.uploadfiles ); { 28 - total uploads }
writeln(fout, user.dnloadfiles ); { 29 - total downloads }
writeln(fout, '0' );          { 30 - daily download K total }
writeln(fout, '999999' );     { 31 - daily download max. K limit }

close( fout )

end; { GAP }
(**************************************************************************)
PROCEDURE QBBS( capitals : boolean );

const
  doorfile = 'DORINFO';

var
  fout : text;

begin

Assign(fout, loc + doorfile + node + '.DEF' );
Rewrite( fout );

if capitals then
begin
  writeln( fout, upper(cnf.bbs) );            {BBS name}
  writeln( fout, upper(cnf.sysfirst) );       {sysop first name}
  writeln( fout, upper(cnf.syslast) );        {sysop last name}
end
else
begin
  writeln( fout, cnf.bbs );            {BBS name}
  writeln( fout, cnf.sysfirst );       {sysop first name}
  writeln( fout, cnf.syslast );        {sysop last name}
end;

if dte <> 0 then
 writeln( fout, 'COM' + com )        {COM Port w/o colon}
else
 writeln( fout, 'COM0');
write( fout, dte );
writeln( fout, ' BAUD,N,8,1');       {Baud rate (DTE) w/ parity, bits, stop}
writeln( fout, '0' );                {dummy parameter}
writeln( fout, fname );              {user's first name}
writeln( fout, lname );              {user's last name}
writeln( fout, chopnull(user.home) );{user's hometown}
if ansi then
  writeln( fout, '1' )               {ANSI ON}
else
  writeln( fout, '0' );              {ANSI OFF}

if user.level = ord('0') then
  writeln( fout, '32000')            {sysop security level}
else
  writeln( fout, cnf.sl );           {std security level}
writeln( fout, min );                {minutes left online}

Close( fout );

end; {QBBS}
(**************************************************************************)

PROCEDURE UI;

const
  doorfile = 'USERINFO.TXT';

var
  fout : text;
  secds : word;

begin

Assign(fout, loc + doorfile );
Rewrite( fout );

writeln( fout, full );
writeln( fout, dte );
writeln( fout, '8' );
secds := min * 60;
writeln( fout, secds );
if dte <> 0 then
  writeln( fout, com )
else
  writeln( fout, 'LOCAL' );

Close( fout );

end; {UI}
(**************************************************************************)
{$IFDEF DWORKS20}
PROCEDURE WC1;

const
  doorfile = 'CALLINFO.BBS';

var
  fout : text;
  z,t  : string;

begin

Assign(fout, loc + doorfile );
Rewrite( fout );

writeln( fout, full );      { full name }
Case dte of
  0    : writeln( fout, 'LOCAL');
  300  : writeln( fout, '1' );
  1200 : writeln( fout, '2' );
  2400 : writeln( fout, '0' );
  9600..38400 : writeln( fout, '3' );
end; {case..of}             { dte speed code }
writeln( fout, chopnull(user.home) );
writeln( fout, cnf.sl );
writeln( fout, min );
if ansi then
   writeln( fout, 'COLOR' )
else
   writeln( fout, 'MONO' );
writeln( fout, chopnull(user.password) );
writeln( fout, '2' );
writeln( fout, timeon );            { ** Time on so far }
writeln( fout, currenttime );       { ** current time }
writeln( fout, logontime );         { ** logon time }
writeln( fout, 'A' );
writeln( fout, '0' );
writeln( fout, '1000' );
writeln( fout, '9999' );
writeln( fout, '9999' );
writeln( fout, phone );
writeln( fout, ldate + ' ' + user.lasttime );    { ** last date & time }
writeln( fout, 'NOVICE' );
writeln( fout, 'N' );
writeln( fout, ldate );          { last date on }
writeln( fout, '200' );
writeln( fout, user.pgln );         { ** page length }
writeln( fout, '10' );
writeln( fout, '10' );
writeln( fout, '20' );
writeln( fout, '8' );
if dte=0 then
  writeln( fout, 'LOCAL' )
else
  writeln( fout, 'REMOTE' );
writeln( fout, 'COM'+com );
writeln( fout, '01/01/70' );

Close( fout );

end; {WC1}
{$ENDIF}  {use the wc routine (newer) below}
(**************************************************************************)

PROCEDURE WC;

const
  doorfile = 'CALLINFO.BBS';

var
  fout : text;

begin

Assign(fout, loc + doorfile );
Rewrite( fout );

writeln( fout, full );      { full name }
Case dte of
  0    : writeln( fout, '5');
  300  : writeln( fout, '1' );
  1200 : writeln( fout, '2' );
  2400 : writeln( fout, '0' );
  9600 : writeln( fout, '3' );
 19200..57600 : writeln( fout, '4' );
end; {case..of}             { dte speed code }
writeln( fout, chopnull(user.home) );
writeln( fout, cnf.sl );
writeln( fout, min );
if ansi then
   writeln( fout, 'COLOR' )
else
   writeln( fout, 'MONO' );
writeln( fout, chopnull(user.password) );
writeln( fout, '2' );               { User ref number in user file - dummy }
writeln( fout, timeon );            { ** Time on so far }
writeln( fout, currenttime );       { ** current time }
writeln( fout, logontime);          { ** logon time w/ date }
writeln( fout, 'A' );               { Confs joined (folders) }
writeln( fout, '0' );               { Daily DL }
writeln( fout, '1000' );
writeln( fout, '9999' );
writeln( fout, '9999' );
writeln( fout, phone );
writeln( fout, ldate + ' ' + user.lasttime );  { ** last date & time }
writeln( fout, 'NOVICE' );
writeln( fout, 'N' );             { Protocol used }
writeln( fout, ldate );             { ** last date }
writeln( fout, '200' );             { ** Times on }
writeln( fout, user.pgln );         { ** page length }
writeln( fout, '1' );               { highest msg read in conf joined }
writeln( fout, '10' );              { uploads }
writeln( fout, '20' );              { downloads }
writeln( fout, '8' );               { Data bits }
if dte=0 then
  writeln( fout, 'LOCAL' )
else
  writeln( fout, 'REMOTE' );
writeln( fout, 'COM'+com );         { COM0 is local }
if user.birthdate_verif then        { birthdate }
 writeln( fout, copy(user.birthdate,5,2) +'/'+copy(user.birthdate,7,2)+'/'+ copy(user.birthdate,3,2) )
else
 writeln( fout, '01/01/70');
writeln( fout, dte );               { ** fixed dte rate or org baud rate }
if dte = 0 then
  writeln( fout, 'FALSE' )          { AlreadyConnected: false if local, else true }
else
  writeln( fout, 'TRUE' );
if dte > 2400 then
  writeln( fout, 'MNP/ARQ Connection') { Connection type: 'Normal Connection' or 'MNP/ARQ Connection' }
else
  writeln( fout, 'Normal Connection');
writeln( fout, '23:59' );           { time off }
writeln( fout, node );              { node number }
writeln( fout, '1' );               { Door Number }

Close( fout );

end; {WC}
(**************************************************************************)

PROCEDURE DRWY;

const
  doorfile = 'DOOR.SYS';

var
  fout : text;

begin

Assign(fout, loc + doorfile );
Rewrite( fout );
writeln( fout, full );      { USER NAME, first and last }
if dte = 0 then
  writeln( fout, '0' )
else
  writeln( fout, com );     { Port number - either a 1, 2 or 0 for local }
writeln( fout, dte );       { Baud rate the port needs to be opened at }
writeln( fout, min );       { Time left - integer less than 32767 in min }
if ansi then
   writeln( fout, 'G' )
else
   writeln( fout, 'M' );    { "G" for graphics, "M" for mono }

if cnf.ala then
   writeln( fout, 'A' )
else
   writeln( fout, 'S' );    { "A" for ALARM, "S" for silent }

Close( fout );

end; {DRWY}
(**************************************************************************)

PROCEDURE WWIVGATE;

const
  doorfile = 'GT-WWIV.BAT';

var
  s : string;
  fout : text;
  dtetxt : string;

begin

Assign(fout, loc + doorfile );
Rewrite( fout );

Str(dte, dtetxt);

s := 'BBS /B' + dtetxt + ' /O /H';

writeln( fout, s );

close( fout ); {Allen Prunty 2/22/91}

end; {WWIVGATE}
(**************************************************************************)

PROCEDURE QBBSGATE;

const
  doorfile = 'GT-QBBS.BAT';

var
  s : string;
  fout : text;
  dtetxt, mintxt : string;

begin

Assign(fout, loc + doorfile );
Rewrite( fout );

Str(dte, dtetxt);
Str(min, mintxt);

if dte = 0 then
  s := 'QUICKBBS -L'
else
  s := 'QUICKBBS -B' + dtetxt + ' -T' + mintxt;

writeln( fout, s );

close( fout );  {Allen Prunty 2/22/91}

end; {QBBSGATE}
(**************************************************************************)

PROCEDURE PCB12;

type
user12 = record
    whole : array[1..25] of char;
     city : array[1..24] of char;
       pw : array[1..12] of char;
dataphone : array[1..13] of char;
homephone : array[1..13] of char;
 lastdate : array[1..8] of char;
 lasttime : array[1..5] of char;
   expert : char;
 protocol : char;
  confreg : array[1..9] of char;
 lastconf : char;
   rejoin : char;
  lastdir : array[1..6] of char;
 security : integer;
  timeson : integer;
     pgln : integer;
      lr0 : integer;
      lr1 : integer;
      lr2 : integer;
      lr3 : integer;
      lr4 : integer;
      lr5 : integer;
      lr6 : integer;
      lr7 : integer;
      lr8 : integer;
      lr9 : integer;
    numup : integer;
  numdown : integer;
  elapsed : integer;
   delete : char;
  regdate : array[1..6] of char;
   expsec : integer;
  expconf : array[1..9] of char;
dailydown : comp;
 usercomment : array[1..30] of char;
sysopcomment : array[1..30] of char;
   space1 : array[1..19] of char;
 end; {user12}

  sys12 = record
     dis : array[1..2] of char;
     prn : array[1..2] of char;
     bel : array[1..2] of char;
     ala : array[1..2] of char;
 sysflag : array[1..2] of char;
     dte : array[1..4] of char;
   whole : array[1..27] of char;
   first : array[1..15] of char;
      gr : array[1..2] of char;
      pw : array[1..12] of char;
 userrec : integer;
   logon : BReal;
   allow : BReal;
exitdoor : BReal;
  timeon : array[1..5] of char;
confexit : integer;
   conf1 : integer;
   conf2 : integer;
   conf3 : integer;
   conf4 : integer;
   conf5 : integer;
   conf6 : integer;
   conf7 : integer;
   conf8 : integer;
   conf9 : integer;
 confadd : integer;
dailydown: comp;
timecred : integer;
    lang : array[1..4] of char;
     ecc : array[1..2] of char;
nodechat : char;
end; {sys12}

const
  doorfile1 = 'PCBOARD.SYS';
  doorfile2 = 'PCBOARD.DAT';
  doorfile3 = 'USERS';
  no = '0';
  yes = '-1';

var
  i,a : integer;
  j : string;
  fout : text;
  fs12 : file of sys12;
  fu12 : file of user12;
    sy : sys12;
    us : user12;
dtetxt : string;
dcetxt : string;

begin

{ fill all variables }
  fillchar(sy, sizeof(sy), #32);

{ Assign variables }
  Str(dte, dtetxt);
  Str(dce, dcetxt);

  if cnf.dis then sy.dis := '-1' else sy.dis:= ' 0';
  if cnf.prn then sy.prn := '-1' else sy.prn:= ' 0';
  if cnf.bel then sy.bel := '-1' else sy.bel:= ' 0';
  if cnf.ala then sy.ala := '-1' else sy.ala:= ' 0';

  if dte > 2400 then
    sy.ecc := '-1' else sy.ecc := ' 0';

  if ansi then sy.gr := '-1' else sy.gr := ' 0';

  if dte = 0 then
    sy.dte := 'Loca'
  else
   begin
   for i := 1 to length(dtetxt) do
     sy.dte[i] := dtetxt[i];
   end;

  for i := 1 to length(full) do
    sy.whole[i] := full[i];

  for i := 1 to length(fname) do
    sy.first[i] := fname[i];

  if ansi then sy.gr := '-1' else sy.gr := ' 0';

  j := chopnull(user.password);
  for i := 1 to length(j) do
    sy.pw[i] := j[i];

  sy.userrec := 2;

  PRealtoBReal( (logontimeinmin*60.0), sy.logon ); {logon time in seconds}
  PRealtoBReal( (maintimeleft * 60.0), sy.allow ); {allowed time in seconds}
  PRealtoBReal( TimeinSecs,sy.exitdoor );        {exit to door in seconds}

  for i := 1 to length(logontime) do
    sy.timeon[i] := logontime[i];

  sy.confexit := 0;
  sy.conf1 := 0;
  sy.conf2 := 0;
  sy.conf3 := 0;
  sy.conf4 := 0;
  sy.conf5 := 0;
  sy.conf6 := 0;
  sy.conf7 := 0;
  sy.conf8 := 0;
  sy.conf9 := 0;
sy.confadd := 0;

  sy.dailydown := 9999;
  sy.timecred := 0;

  if dte > 2400 then
    sy.ecc := '-1' else sy.ecc := ' 0';

  sy.nodechat := 'U';

Assign( fs12, loc + doorfile1 );
rewrite( fs12 );
write( fs12, sy );
close( fs12 );

{---------------------------- USER RECORDS ----------------------------}
{ fill USERS variables v12 }

fillchar( us, sizeof(us), #32 );

{Sysop Record}
 j := cnf.sysfirst + ' ' + cnf.syslast;
  for i := 1 to length(j) do
    us.whole[i] := j[i];

 j := 'Home Sweet Home';
  for i:= 1 to length(j) do
    us.city[i] := j[i];

 j := 'SYSOP';
    for i := 1 to length(j) do
       us.pw[i] := j[i];

 for i := 1 to length(phone) do
  begin
    us.dataphone[i] := phone[i];
    us.homephone[i] := phone[i];
  end;

 j := ldate;
 for i := 1 to length(j) do
   us.lastdate[i] := j[i];

 j := chopnull(user.lasttime);
 for i := 1 to length(j) do
   us.lasttime[i] := j[i];

if user.expert then
   us.expert := 'Y'
else
   us.expert := 'N';

 us.protocol := 'N';
  us.confreg := '100000000';
 us.lastconf := '1';
   us.rejoin := 'N';
  us.lastdir := '900901';
 us.security := cnf.sl;
  us.timeson := user.timeson;
     us.pgln := user.pgln;
      us.lr0 := 0;
      us.lr1 := 0;
      us.lr2 := 0;
      us.lr3 := 0;
      us.lr4 := 0;
      us.lr5 := 0;
      us.lr6 := 0;
      us.lr7 := 0;
      us.lr8 := 0;
      us.lr9 := 0;
    us.numup := user.uploadfiles;
  us.numdown := user.dnloadfiles;
  us.elapsed := 0;
   us.delete := 'N';
  us.regdate := '900901';
   us.expsec := 1;
  us.expconf := '100000000';
us.dailydown := 9999;

j := 'DoorWorks '+ver;
for i := 1 to length(j) do
  us.usercomment[i] := j[i];
j := 'TRC Development 606-269-7128';
for i := 1 to length(j) do
  us.sysopcomment[i] := j[i];

Assign( fu12, loc + doorfile3 );
Rewrite( fu12 );

write( fu12, us );


{ User Record - remainder was filled in sysop record... automatically
  copied to this record - only changing (below) the fields that change. }
    fillchar(us.whole, sizeof(us.whole), #32);
    fillchar(us.city, sizeof(us.city), #32);
    fillchar(us.pw, sizeof(us.pw), #32);

    for i := 1 to length(full) do
      us.whole[i] := full[i];
    j := chopnull(user.home);
    for i := 1 to length(j) do
     us.city[i] := j[i];
    j := chopnull(user.password);
    for i := 1 to length(j) do
       us.pw[i] := j[i];

write( fu12, us );
close( fu12 );

{----------------------- PCBOARD.DAT file ---------------------------------}

Assign( fout, loc + doorfile2 );
Rewrite( fout );

writeln( fout, '*** PCBoard Version 12.1 data file ***');
writeln( fout, cnf.sysfirst + ' ' + cnf.syslast);
writeln( fout, '' );
writeln( fout, yes );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, 'MSGS' );
writeln( fout, 'CALLER' );
writeln( fout, '\' );
writeln( fout, 'WELCOME' );
writeln( fout, 'NEWUSER' );

if loc <> '' then                      { write users file in the dir pointed to or current dir if loc=''}
  writeln( fout, loc + 'USERS')
else
  writeln( fout, currentdir + 'USERS' );

writeln( fout, 'CNAMES' );
writeln( fout, 'FSEC' );
writeln( fout, 'PWRD' );
writeln( fout, 'TCAN' );
writeln( fout, 'REMOTE' );
writeln( fout, 'ANSWER' );
writeln( fout, 'NEWREG' );
writeln( fout, 'DOORS' );
writeln( fout, 'NEWS' );
writeln( fout, 'USERNET.DAT' );
writeln( fout, 'DOWNLOAD.TXT' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '60' );
writeln( fout, 'ATZ' );
writeln( fout, 'ATH1' );
writeln( fout, 'COM'+com );
if cnf.lock <> 0 then
  writeln( fout, cnf.lock )
else
  writeln( fout, dte );

writeln( fout, yes );
writeln( fout, '00:01');
writeln( fout, '23:59');

{ security levels for functions 'A-Z', 'DOOR', 'OPEN', 'NODE', 'CHAT' }

for i := 1 to 30 do
  writeln( fout, no );

writeln( fout, '1' );
writeln( fout, no );
writeln( fout, no );
writeln( fout, no );
writeln( fout, no );
writeln( fout, yes );
writeln( fout, no );
writeln( fout, no );
writeln( fout, no );
writeln( fout, no );
writeln( fout, '' );
writeln( fout, no );
writeln( fout, no );
writeln( fout, '00:00');
writeln( fout, '99' );
writeln( fout, '00' );
writeln( fout, '37' );

if lanpath <> '' then
  writeln( fout, yes )
else
  writeln( fout, no );

writeln( fout, node );
writeln( fout, no );

for i := 1 to 10 do
  writeln( fout, '' );  {Shift-Fn defs}

writeln( fout, 'Leave a comment for the sysop [Y/N]?' );
writeln( fout, cnf.bbs );
writeln( fout, '1' );
writeln( fout, yes );
writeln( fout, '32' );
writeln( fout, yes );
writeln( fout, yes );
writeln( fout, yes );
writeln( fout, no );
writeln( fout, no );
writeln( fout, yes );
writeln( fout, '8' );
writeln( fout, no );
writeln( fout, no );
writeln( fout, no );
writeln( fout, no );
writeln( fout, yes );
writeln( fout, no );
writeln( fout, no );
writeln( fout, no );
writeln( fout, yes );
writeln( fout, '100' );
writeln( fout, no );
writeln( fout, no );
writeln( fout, '20' );
writeln( fout, no );
writeln( fout, no );
writeln( fout, '' );

close( fout );

end; {PCB12}
(***************************************************************************)

PROCEDURE PCB14;

type
user14 = record
    whole : array[1..25] of char;
     city : array[1..24] of char;
       pw : array[1..12] of char;
dataphone : array[1..13] of char;
homephone : array[1..13] of char;
 lastdate : array[1..6] of char;
 lasttime : array[1..5] of char;
   expert : char;
 protocol : char;
   space1 : char;
  lastdir : array[1..6] of char;
 security : char;
  timeson : integer;
     pgln : char;
    numup : integer;
  numdown : integer;
dailydown : comp;
usercomment : array[1..30] of char;
sysopcomment : array[1..30] of char;
  elapsed : integer;
   subreg : array[1..6] of char;
   subexp : char;
arealastin : char;
  areareg : array[1..5] of char;
  exparea : array[1..5] of char;
 userarea : array[1..5] of char;
bytesdown : comp;
  bytesup : comp;
   delete : char;
    lmr0  : BReal;
    lmr1  : BReal;
    lmr2  : BReal;
    lmr3  : BReal;
    lmr4  : BReal;
    lmr5  : BReal;
    lmr6  : BReal;
    lmr7  : BReal;
    lmr8  : BReal;
    lmr9  : BReal;
    lmr10 : BReal;
    lmr11 : BReal;
    lmr12 : BReal;
    lmr13 : BReal;
    lmr14 : BReal;
    lmr15 : BReal;
    lmr16 : BReal;
    lmr17 : BReal;
    lmr18 : BReal;
    lmr19 : BReal;
    lmr20 : BReal;
    lmr21 : BReal;
    lmr22 : BReal;
    lmr23 : BReal;
    lmr24 : BReal;
    lmr25 : BReal;
    lmr26 : BReal;
    lmr27 : BReal;
    lmr28 : BReal;
    lmr29 : BReal;
    lmr30 : BReal;
    lmr31 : BReal;
    lmr32 : BReal;
    lmr33 : BReal;
    lmr34 : BReal;
    lmr35 : BReal;
    lmr36 : BReal;
    lmr37 : BReal;
    lmr38 : BReal;
    lmr39 : BReal;
   space2 : array[1..15] of char;
 end; {user14}

  sys14 = record
     dis : array[1..2] of char;
     prn : array[1..2] of char;
     bel : array[1..2] of char;
     ala : array[1..2] of char;
 sysflag : char;
     ecc : array[1..2] of char;
      gr : char;
nodechat : char;
     dte : array[1..5] of char;
     dce : array[1..5] of char;
 userrec : integer;
   first : array[1..15] of char;
      pw : array[1..12] of char;
  timeon : integer;
timeused : integer;
   logon : array[1..5] of char;
timeallow : integer;
 dlallow : integer;
    area : char;
  areain : array[1..5] of char;
   areay : array[1..5] of char;
highestadd : integer;
chatcredit : integer;
    lang : array[1..4] of char;
   whole : array[1..25] of char;
     min : integer;
    node : char;
eventtime: array[1..5] of char;
eventactive : array[1..2] of char;
   slide : array[1..2] of char;
memorize : BReal;
 comport : char;
   space : array[1..2] of char;
end; {sys14}

const
  doorfile1 = 'PCBOARD.SYS';
  doorfile2 = 'PCBOARD.DAT';
  doorfile3 = 'USERS';
  no = '0';
  yes = '-1';

var
  i,a : integer;
  j : string;
  fout : text;
  fs14 : file of sys14;
  fu14 : file of user14;
    sy : sys14;
    us : user14;
dtetxt : string;
dcetxt : string;

begin

{ fill all variables }
  fillchar(sy, sizeof(sy), #32);

{ Assign variables }
  Str(dte, dtetxt);
  Str(dce, dcetxt);

  if cnf.dis then sy.dis := '-1' else sy.dis:= ' 0';
  if cnf.prn then sy.prn := '-1' else sy.prn:= ' 0';
  if cnf.bel then sy.bel := '-1' else sy.bel:= ' 0';
  if cnf.ala then sy.ala := '-1' else sy.ala:= ' 0';

  if dte > 2400 then
    sy.ecc := '-1' else sy.ecc := ' 0';
  sy.sysflag := ' ';
  if ansi then sy.gr := 'Y' else sy.gr := 'N';
  sy.nodechat := 'U';

  for i := 1 to length(dtetxt) do
    sy.dte[i] := dtetxt[i];

  if dce = 0 then
    begin
    sy.dte := 'Local';
    sy.dce := 'Local'
    end
  else
  begin
  for i := 1 to length(dcetxt) do
    sy.dce[i] := dcetxt[i];
  end;

  sy.userrec := 2;
  for i := 1 to length(fname) do
    sy.first[i] := fname[i];
  j := chopnull(user.password);
  for i := 1 to length(j) do
    sy.pw[i] := j[i];
  sy.timeon := logontimeinmin;
{ sy.timeused := 0 - timeon; } {old logic}
  sy.timeused := 0;            {new logic - assume just entered}
  for i := 1 to length(logontime) do
    sy.logon[i] := logontime[i];
  sy.timeallow := maintimeleft;
  sy.dlallow := 9999;
  sy.area := chr(0);
  sy.highestadd := 0;
  sy.chatcredit := 0;
  for i := 1 to length(full) do
    sy.whole[i] := full[i];
  sy.min := min;
  val(node, a, i);
  sy.node := chr(a);
  sy.eventtime := '00:00';
  sy.eventactive := ' 0';
  sy.slide := '-1';
  PRealtoBReal( 0, sy.memorize );
  sy.comport := com[1];

Assign( fs14, loc + doorfile1 );
rewrite( fs14 );
write( fs14, sy );
close( fs14 );

{---------------------------- USER RECORDS ----------------------------}
{ fill USERS variables - v14 }

fillchar( us, sizeof(us), #32 );

{Sysop Record}
 j := cnf.sysfirst + ' ' + cnf.syslast;
  for i := 1 to length(j) do
    us.whole[i] := j[i];
 j := 'SYSOP';
    for i := 1 to length(j) do
       us.pw[i] := j[i];
 for i := 1 to length(phone) do
  begin
    us.dataphone[i] := phone[i];
    us.homephone[i] := phone[i];
  end;
 j := ldate[7]+ldate[8]+ldate[1]+ldate[2]+ldate[4]+ldate[5];
 for i := 1 to length(j) do
   us.lastdate[i] := j[i];
 j := chopnull(user.lasttime);
 for i := 1 to length(j) do
   us.lasttime[i] := j[i];
if user.expert then
   us.expert := 'Y'
else
   us.expert := 'N';
 us.protocol := 'N';
  us.lastdir := '900901';
 us.security := chr(cnf.sl);
  us.timeson := user.timeson;
     us.pgln := chr(user.pgln);
    us.numup := user.uploadfiles;
  us.numdown := user.dnloadfiles;
us.dailydown := 0;
j := 'DoorWorks '+ver;
for i := 1 to length(j) do
  us.usercomment[i] := j[i];
j := 'TRC Development 606-269-7128';
for i := 1 to length(j) do
  us.sysopcomment[i] := j[i];

  us.elapsed := 0;         { consider 1st time on today }
   us.subreg := '900901';
   us.subexp := chr(cnf.sl);
us.arealastin := chr(0);
us.bytesdown := user.dnloadk;
  us.bytesup := user.uploadk;
   us.delete := 'N';
    PRealtoBReal( 0, us.lmr0 );
    PRealtoBReal( 0, us.lmr1 );
    PRealtoBReal( 0, us.lmr2 );
    PRealtoBReal( 0, us.lmr3 );
    PRealtoBReal( 0, us.lmr4 );
    PRealtoBReal( 0, us.lmr5 );
    PRealtoBReal( 0, us.lmr6 );
    PRealtoBReal( 0, us.lmr7 );
    PRealtoBReal( 0, us.lmr8 );
    PRealtoBReal( 0, us.lmr9 );
    PRealtoBReal( 0, us.lmr10 );
    PRealtoBReal( 0, us.lmr11 );
    PRealtoBReal( 0, us.lmr12 );
    PRealtoBReal( 0, us.lmr13 );
    PRealtoBReal( 0, us.lmr14 );
    PRealtoBReal( 0, us.lmr15 );
    PRealtoBReal( 0, us.lmr16 );
    PRealtoBReal( 0, us.lmr17 );
    PRealtoBReal( 0, us.lmr18 );
    PRealtoBReal( 0, us.lmr19 );
    PRealtoBReal( 0, us.lmr20 );
    PRealtoBReal( 0, us.lmr21 );
    PRealtoBReal( 0, us.lmr22 );
    PRealtoBReal( 0, us.lmr23 );
    PRealtoBReal( 0, us.lmr24 );
    PRealtoBReal( 0, us.lmr25 );
    PRealtoBReal( 0, us.lmr26 );
    PRealtoBReal( 0, us.lmr27 );
    PRealtoBReal( 0, us.lmr28 );
    PRealtoBReal( 0, us.lmr29 );
    PRealtoBReal( 0, us.lmr30 );
    PRealtoBReal( 0, us.lmr31 );
    PRealtoBReal( 0, us.lmr32 );
    PRealtoBReal( 0, us.lmr33 );
    PRealtoBReal( 0, us.lmr34 );
    PRealtoBReal( 0, us.lmr35 );
    PRealtoBReal( 0, us.lmr36 );
    PRealtoBReal( 0, us.lmr37 );
    PRealtoBReal( 0, us.lmr38 );
    PRealtoBReal( 0, us.lmr39 );

Assign( fu14, loc + doorfile3 );
Rewrite( fu14 );

write( fu14, us );


{ User Record - remainder was filled in sysop record... automatically
  copied to this record - only changing (below) the fields that change. }
    fillchar(us.whole, sizeof(us.whole), #32);
    fillchar(us.city, sizeof(us.city), #32);
    fillchar(us.pw, sizeof(us.pw), #32);

    for i := 1 to length(full) do
      us.whole[i] := full[i];
    j := chopnull(user.home);
    for i := 1 to length(j) do
     us.city[i] := j[i];
    j := chopnull(user.password);
    for i := 1 to length(j) do
       us.pw[i] := j[i];

write( fu14, us );
close( fu14 );

{----------------------- PCBOARD.DAT file ---------------------------------}

Assign( fout, loc + doorfile2 );
Rewrite( fout );

writeln( fout, '*** PCBoard Version 14.0 data file ***');
writeln( fout, cnf.sysfirst + ' ' + cnf.syslast);
writeln( fout, '' );
writeln( fout, yes );
writeln( fout, yes );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '110' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );

if loc <> '' then                      { write users file in the dir pointed to or in the current dir if loc=''}
  writeln( fout, loc + 'USERS' )
else
  writeln( fout, currentdir + 'USERS' );

writeln( fout, 'CALLER' );
writeln( fout, 'CNAMES' );
writeln( fout, 'PWRD' );
writeln( fout, 'FSEC' );
writeln( fout, 'UPSEC' );
writeln( fout, 'TCAN' );
writeln( fout, 'WELCOME' );
writeln( fout, 'NEWUSER' );
writeln( fout, 'CLOSED' );
writeln( fout, 'WARNING' );
writeln( fout, 'EXPIRED' );
writeln( fout, 'USERNET.DAT' );
writeln( fout, 'CNFN' );
writeln( fout, 'NEWASK' );
writeln( fout, 'NEWREG' );
writeln( fout, 'PCBPROT.DAT' );
writeln( fout, 'DOWNLOAD.TXT' );
writeln( fout, 'SCRIPT0' );
writeln( fout, 'ANSWER0' );
writeln( fout, 'PCBML.DAT' );
writeln( fout, 'GROUP' );
writeln( fout, '60' );
writeln( fout, 'COM'+com );
if cnf.lock <> 0 then
 begin
  writeln( fout, cnf.lock );
  writeln( fout, yes );
 end
else
 begin
   writeln( fout, dte );
   writeln( fout, no );
 end;

writeln( fout, 'ATZ' );
writeln( fout, 'ATH1' );
writeln( fout, no );
if cnf.hayes then
  writeln( fout, yes )
else
  writeln( fout, no );

writeln( fout, no );
writeln( fout, no );
writeln( fout, yes );
writeln( fout, no );
writeln( fout, no );
writeln( fout, no );
writeln( fout, yes );
writeln( fout, '00:01' );
writeln( fout, '23:59' );
writeln( fout, no );
writeln( fout, no );
writeln( fout, yes );
writeln( fout, no );
writeln( fout, no );
writeln( fout, yes );
writeln( fout, no );
writeln( fout, no );
writeln( fout, no );
writeln( fout, no );
writeln( fout, no );
writeln( fout, yes );
writeln( fout, no );
writeln( fout, no );
writeln( fout, yes );
writeln( fout, yes );
writeln( fout, yes );
writeln( fout, no );
writeln( fout, yes );
writeln( fout, yes );
if dte > 2400 then
  writeln( fout, no )
else
  writeln( fout, yes );
writeln( fout, '5' );
if lanpath <> '' then
  writeln( fout, yes )
else
  writeln( fout, no );
writeln( fout, node );
writeln( fout, '10' );
writeln( fout, '15' );
writeln( fout, cnf.bbs );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, '' );
writeln( fout, 'X' );
writeln( fout, no );
writeln( fout, '99' );
writeln( fout, '37' );
writeln( fout, no );
writeln( fout, no );
writeln( fout, '00:00' );
writeln( fout, '5' );
writeln( fout, no );
writeln( fout, no );
writeln( fout, '8' );
writeln( fout, no );
writeln( fout, no );
writeln( fout, '300' );
for i := 1 to 30 do
  writeln( fout, '9' );
writeln( fout, '10' );
writeln( fout, '0' );

close( fout );

end; {PCB14}
(***************************************************************************)
PROCEDURE OO; {Operation Overkill II}

const
  doorfile = 'BBSINFO.OO';

var
  fout : text;

begin

Assign( fout, loc + doorfile );
Rewrite( fout );

writeln( fout, full );
if dte = 0 then
  writeln( fout, '0' )
else
  writeln( fout, com );
writeln( fout, dte );
writeln( fout, min );

close( fout );

end; {OO}
(**************************************************************************)
PROCEDURE RA100; {RemoteAccess v1.00}

type
  USERSXIrecord  = record
                     Handle         : String[35];
                     Comment        : String[80];
                     FirstDate      : string[8];
                     CombinedInfo   : array[1..25] of byte;
                     BirthDate      : string[8];
                     SubDate        : string[8];
                     ScreenWidth    : Byte;
                     ExtraSpace     : Array[1..83] of Byte;
                   end;

  USERSrecord    = record
                     Name           : string[35];
                     Location       : String[25];
                     Password       : String[15];
                     DataPhone,
                     VoicePhone     : String[12];
                     LastTime       : string[5];
                     LastDate       : string[8];
                     Attribute      : Byte;

                      { Bit 0 : Deleted
                            1 : Clear screen
                            2 : More prompt
                            3 : ANSI
                            4 : No-kill
                            5 : Xfer priority
                            6 : Full screen msg editor
                            7 : Quiet mode }

                     Flags          : array[1..4] of byte;
                     Credit,
                     Pending        : Word;
                     MsgsPosted,
                     LastRead,
                     Security,
                     NoCalls,
                     Uploads,
                     Downloads,
                     UploadsK,
                     DownloadsK     : Word;
                     TodayK,
                     Elapsed        : Integer;
                     ScreenLength   : Word;
                     LastPwdChange,
                     Attribute2,

                      { Bit 0 : Hot-keys
                            1 : AVT/0
                            2 : Full screen message viewer
                            3 : Hidden from userlist }

                     Group          : Byte;
                     XIrecord       : Word;
                     ExtraSpace     : array[1..3] of Byte;
                   end;

  EVENTrecord    = record
                     Status         : Byte; { 0=Deleted 1=Enabled 2=Disabled }
                     StartTime      : string[5];
                     ErrorLevel     : Byte;
                     Days           : Byte;
                     Forced         : Boolean;
                     LastTimeRun    : string[8];
                   end;

  SYSINFOrecord  = record
                     TotalCalls     : LongInt;
                     LastCaller     : string[35];
                     ExtraSpace     : array[1..128] of Byte;
                   end;

  TIMELOGrecord  = record
                     StartDate      : string[8];
                     BusyPerHour    : array[0..23] of Word;
                     BusyPerDay     : array[0..6] of Word;
                   end;

  EXITINFOrecord = record
                     Baud             : Word;
                     SysInfo          : SYSINFOrecord;
                     TimeLogInfo      : TIMELOGrecord;
                     UserInfo         : USERSrecord;
                     EventInfo        : EVENTrecord;
                     NetMailEntered,
                     EchoMailEntered  : Boolean;
                     LoginTime        : string[5];
                     LoginDate        : string[8];
                     TimeLimit        : Word;
                     LoginSec,
                     Credit           : LongInt;
                     UserRecord       : Integer;
                     ReadThru,
                     NumberPages,
                     DownloadLimit    : Word;
                     TimeOfCreation   : string[5];
                     LogonPassword    : String[15];
                     WantChat         : Boolean;

                     DeductedTime     : Integer;
                     MenuStack        : Array[1..50] of String[8];
                     MenuStackPointer : Byte;
                     UserXIinfo       : USERSXIrecord;
                     ErrorFreeConnect,
                     SysopNext        : Boolean;

                     EMSI_Session     : Boolean;        { These fields hold  }
                     EMSI_Crtdef,                       { data related to an }
                     EMSI_Protocols,                    { EMSI session       }
                     EMSI_Capabilities,
                     EMSI_Requests,
                     EMSI_Software    : String[40];
                     Hold_Attr1,
                     Hold_Attr2,
                     Hold_Len         : Byte;

                     ExtraSpace       : Array[1..100] of Byte;
                 end;

const
  doorfile = 'EXITINFO.BBS';

var
  xdate : string[8];
  y,m,d,dow : word;
  xy,xm,xd : string[4];
  i : integer;
  fout : file of EXITINFOrecord;
  ei : EXITINFOrecord;
  tl : TIMELOGrecord;
  si : SYSINFOrecord;
  ev : EVENTrecord;
  us : USERSrecord;
  xi : USERSXIrecord;

begin

  GetDate(y,m,d,dow);
  str(y, xy);
  str(m, xm);
  str(d, xd);
  xdate := xm+'/'+xd+'/'+xy[3]+xy[4];

  {USERSXI}
  for i := 1 to 25 do
    xi.combinedinfo[i] := 0;
  xi.handle := full;
  xi.comment := pname + ' ' + ver + ', (c) Copyright Cory Wright 1990-1994, 606-269-7128';
  xi.firstdate := copy(user.firstdate,5,2) + '/' + copy(user.firstdate,7,2) + '/' + copy(user.firstdate,1,4);
  if user.birthdate_verif then
    xi.birthdate := copy(user.birthdate,5,2) + '/' + copy(user.birthdate,7,2) + '/' + copy(user.birthdate,3,2)
  else
    xi.birthdate := '01/01/70';
  xi.subdate := '01/01/70';
  xi.screenwidth := 80;

  {USERS}
  us.name := full;
  us.location := chopnull(user.home);
  us.password := chopnull(user.password);
  us.dataphone := phone;
  us.voicephone := phone;
  us.lasttime := chopnull(user.lasttime);
  us.lastdate := ldate;
  if ansi then
    us.attribute := 14
  else
    us.attribute := 6;
  for i := 1 to 4 do
    us.flags[1] := 0;
  us.credit := 0;
  us.pending := 0;
  us.msgsposted := 0;
  us.lastread := 0;
  us.security := cnf.sl;
  us.nocalls := user.timeson;
  us.uploads := user.uploadfiles;
  us.downloads := user.dnloadfiles;
  us.uploadsk := user.uploadk;
  us.downloadsk := user.dnloadk;
  us.todayk := 0;
  us.elapsed := 0;
  us.screenlength := user.pgln;
  us.lastpwdchange := 0;
  us.attribute2 := 0;
  us.group := 0;
  us.xirecord := 1;

  {EVENT}
  ev.status := 2;
  ev.starttime := currenttime;
  ev.errorlevel := 0;
  ev.days := 0;
  ev.forced := false;
  ev.lasttimerun := xdate;

  {SYSINFO}
  si.totalcalls := 1000;
  si.lastcaller := 'unknown';

  {TIMELOG}
  tl.startdate := xdate;
  for i := 0 to 23 do
    tl.busyperhour[i] := 5;
  for i := 0 to 6 do
    tl.busyperday[i] := 5;

  {EXITINFO}
  ei.sysinfo := si;
  ei.timeloginfo := tl;
  ei.userinfo := us;
  ei.eventinfo := ev;
  ei.userxiinfo := xi;
  ei.baud := dte;
  ei.netmailentered := false;
  ei.echomailentered := false;
  ei.logintime := logontime;
  ei.logindate := xdate;
  ei.timelimit := min;
  ei.loginsec := logontimeinmin*60;
  ei.credit := 0;
  ei.userrecord := 1;
  ei.readthru := 0;
  ei.numberpages := 0;
  ei.downloadlimit := 9999;
  ei.timeofcreation := currenttime;
  ei.logonpassword := chopnull(user.password);
  ei.wantchat := false;
  ei.deductedtime := 0;
  for i := 1 to 50 do
    ei.menustack[i] := '';
  ei.menustackpointer := 0;
  if dte > 2400 then
    ei.errorfreeconnect := true
  else
    ei.errorfreeconnect := false;
  ei.sysopnext := false;
  ei.EMSI_Session := false;
  ei.EMSI_Crtdef := '';
  ei.EMSI_Protocols := '';
  ei.EMSI_Capabilities := '';
  ei.EMSI_Requests := '';
  ei.EMSI_Software := '';
  ei.Hold_Attr1 := 0;
  ei.Hold_Attr2 := 0;
  ei.Hold_Len := 0;

  Assign( fout, loc + doorfile );
  Rewrite( fout );
  Write( fout, ei );
  Close( fout );

end; {RA100}
(***************************************************************************)
PROCEDURE SF; {Spitfire}

const
  yes = 'TRUE';
  no = 'FALSE';
  doorfile = 'SFDOORS.DAT';

var
  fout : text;

begin

Assign( fout, loc + doorfile );
Rewrite( fout );

writeln( fout, '1' );          {User Number}(* the record number in SFUSERS.DAT of the caller       *)
writeln( fout, full );         {User Name  }(* the full name of the caller                          *)
writeln( fout, chopnull(user.password) ); {Password   }(* the password of the caller                           *)
writeln( fout, fname );        {First Name }(* the first name of the caller                         *)
writeln( fout, dte );          {Baud Rate  }(* baud rate of the caller - i.e. 2400 { 0 if local }   *)
writeln( fout, com );          {Comm port  }(* comm port being used by SPITFIRE                     *)
writeln( fout, min );          {Time Left  }(* number of minutes the caller has left this log on    *)
writeln( fout, trunc(TimeInSecs) );   {Time       }(* number seconds since midnight when entering the door *)
writeln( fout, gtpath );       {Path       }(* the path in which SPITFIRE.EXE resides {C:\SF\}      *)
if ansi then
  writeln( fout, yes )
else
  writeln( fout, no );         {Ansi_On    }(* TRUE if caller is using ANSI else FALSE              *)
writeln( fout, cnf.sl );         {SecLevel   }(* the security level of the caller                     *)
writeln( fout, user.uploadfiles );{Uploads    }(* the number of uploads the caller has made            *)
writeln( fout, user.dnloadfiles );{Downloads  }(* the number of downloads the caller has made          *)
writeln( fout, min );          {This Time  }(* total number of minutes allowed for this call        *)
writeln( fout, trunc(TimeInSecs) );   {Time On    }(* number of seconds since midnight when logged on      *)
writeln( fout, '0' );          {Extra Time }(* number of seconds the caller has gained since log on *)
writeln( fout, no );           {Sysop Next }(* TRUE if Sysop next feature has been activated        *)
writeln( fout, no );           {Front End  }(* TRUE if SPITFIRE was booted from a front end program *)
if cnf.lock <> 0 then
  writeln( fout, yes )
else
  writeln( fout, no );         {No DTE Lock}(* TRUE if configured for Software Data Flow Control    *)
writeln( fout, dte );          {MaxBaud    }(* maximum baud of the system                           *)
if dte > 2400 then
  writeln( fout, yes )
else
  writeln( fout, no );         {ErrCorrect }(* TRUE if error correction connection                  *)
writeln( fout, '0' );          {LastMConf  }(* last message conference                              *)
writeln( fout, '0' );          {LastFArea  }(* last file area                                       *)
writeln( fout, node );         {Node Number}(* Node on which the caller is logged                   *)
writeln( fout, '999');         {DLs Per Day}(* Number of files allowed to be downloaded per day     *)
writeln( fout, '0' );          {DLs Today  }(* Number of files the caller has downloaded this day   *)
writeln( fout, '9999' );       {Daily Bytes}(* Number of downloadable bytes per day                 *)
writeln( fout, '0' );          {Bytes Today}(* Number of bytes the caller has downloaded this day   *)
writeln( fout, '0' );          {Unknown, present as 0 in v2.8}
writeln( fout, '0' );          {Unknown, present as 0 in v2.8}

close( fout );

end; {SF}
(***************************************************************************)
Procedure WWIV;  {CHAIN.TXT}

const
  yes = '1';
  no = '0';
  doorfile = 'CHAIN.TXT';

var
  fout : text;

begin

Assign( fout, loc + doorfile );
Rewrite( fout );

writeln( fout, '2' );              {user number}
writeln( fout, full );             {alias}
writeln( fout, full );             {real name}
writeln( fout, '' );               {callsign}
writeln( fout, '20' );             {age}
writeln( fout, 'M' );              {sex (M,F)}
writeln( fout, '100');             {gold}
writeln( fout, ldate );            {last call date}
writeln( fout, '80' );             {scr width}
writeln( fout, user.pgln );        {scr length}
writeln( fout, cnf.sl );          {security level (numeric) }
if (full = cnf.sysfirst+' '+cnf.syslast) then
  writeln( fout, yes )             {is sysop 0/1}
else
  writeln( fout, no );
writeln( fout, '0' );              {is cosysop? 0/1}
if ansi then
  writeln( fout, yes )             {ansi 0/1}
else
  writeln( fout, no );
if dte = 0 then
  writeln( fout, no )              {remote? 0/1}
else
  writeln( fout, yes );
writeln( fout, min * 60 );         {seconds left}
writeln( fout, gtpath );           {general files directory}
writeln( fout, gtpath );           {data directory}
writeln( fout, 'SYSOP.LOG' );      {sysops log}
if dte = 0 then
  writeln( fout, 'KB' )            {baud rate: KB=local, 1200=1200, etc }
else
  writeln( fout, dte );
writeln( fout, com );              {com port: 1, 2, etc}
writeln( fout, cnf.bbs );          {bbs name}
writeln( fout, cnf.sysfirst+' '+cnf.syslast );        {sysop name}
writeln( fout, trunc(logontimeinmin * 60.0) ); {time user logged in in seconds}
writeln( fout, trunc(timeon * 60.0) );      {time user has used in second}
writeln( fout, user.uploadk );     {Kb user has uploaded}
writeln( fout, user.uploadfiles ); {# files user has uploaded}
writeln( fout, user.dnloadk );     {Kb user has dl}
writeln( fout, user.dnloadfiles ); {# files user has dl}
writeln( fout, '8N1');             {parity: 7E1 or 8N1}

close( fout );

end; {WWIV}
