(* Released into the public domain April 1, 1995.  No warranties, use at *)
(* your own risk.  Copyright Jason Cory Wright 1995                      *)
Unit DWORKSU;

interface

Uses MiscTTT5, Crt;
procedure InvalidCommandLine( pname, ver, divider : string );
function chopnull( s : string ) : string;
Function Decrypt( s : string ) : string;
FUNCTION TimeinSecs: real;  { seconds format }

implementation

(***************************************************************************)
FUNCTION TimeinSecs: real;  { seconds format }
var
  TTemp,TSec: integer;
begin
  Inline(
    $B4/$2C          { Mov  Ah,$2C       ;function $2C returns:  Ch = Hour    }
    /$CD/$21         { Int  $21          ;        Dh = Seconds,  Cl = Minutes }
    /$30/$E4         { Xor  Ah,Ah                                             }
    /$86/$D6         { Xchg Dh,Dl        ;swap and clear dh                   }
    /$88/$E6         { Mov  Dh,Ah        ;                                    }
    /$89/$56/<TSEC   { Mov  <TSec[Bp],Dx  ;TSec  = Dx                           }
    /$88/$E8         { Mov  Al,Ch        ;Al   = Hour                         }
    /$B3/$3C         { Mov  Bl,60        ;                                    }
    /$F6/$E3         { Mul  Bl           ;Ax   = Hour * 60                    }
    /$30/$ED         { Xor  Ch,Ch                                             }
    /$01/$C8         { Add  Ax,Cx        ;Ax   = Hour * 60 + Minutes          }
    /$89/$46/<TTEMP); { Mov  <TTemp[Bp],Ax ;TTemp = Ax                           }
  TimeinSecs:=60.0 * TTemp + TSec;
  end;
(*********************************************************************)
procedure InvalidCommandLine( pname, ver, divider : string);

begin
           beep; beep;
           delay( 1000 );
           clrscr;
           textcolor( 7 );
           writeln( pname, #32, ver, ' - Invalid command line.');
           writeln( divider );
           writeln('Proper use:  DWORKS Option');
           writeln('        or:  DWORKS Conversion_Type [Target_directory] [/I:textfile_name]');
           writeln('Options:');
           writeln('      CONFIG - Configure DoorWorks (Install registrations, options, etc)');
           writeln('       RESET - Delete door usage files, starts a fresh log file');
           writeln('       LOGIN - Log in a door when entering door with no conversion');
           writeln('      /OUT:X - Log out door #X when exiting a door');
           writeln('/DOORGRAPH:X - Create a door usage graph as bulletins X, X.CBS');
           writeln('   /TOP###:X - Create a door graph with the TOP ### doors in X, X.CBS');
           writeln;
           writeln('Conversion_Type:');
           writeln('          12 - PCBoard 12.X           RA - RemoteAccess v1.XX');
           writeln('          14 - PCBoard 14.X         RBBS - RBBS files');
           writeln('        DRWY - DOORWAY (M. Dudley)  QBBS - QuickBBS files');
           writeln('         GAP - GAP Communications     SF - SpitFire BBS files');
           writeln('     GENERIC - CKIT doors             UI - Milton Gameworks USERINFO.TXT');
           writeln('          WC - Wildcat!             WWIV - WWIV BBS (Wayne Bell)');
           writeln('          OO - Oper. Overkill II  SRDOOR - The Realms (DOORFILE.SR) thru v4.0');
           writeln;
           writeln('    QBBSGATE - Batch for QuickBBS as a door, GT-QBBS.BAT');
           writeln('    WWIVGATE - Batch for WWIV as a door, GT-WWIV.BAT');
           gotoxy(1,24);
           halt(1);
end; {InvalidCommandLine}

(**************************************************************************)
function chopnull( s : string ) : string;

var
 i : integer;
 s2 : string;

begin

  s2 := '';
  for i := 1 to length( s ) do
   begin
     if s[i] <> #0 then
       s2 := s2 + s[i]
     else
       i := length( s ); {exit the for loop}
   end;  {for}

  chopnull := s2;

end;

(****************************************************************************)
Function Decrypt( s : string ) : string;

var
  i : integer;

begin

  for i := 1 to length( s ) do
    s[i] := chr(ord(s[i])-43);

  Decrypt := s;

end; {Decrypt}


END.
