Unit Message;

Interface

Uses Dos;

Type  CNameType = array[1..31] of Char;
      CDateType = array[1..9] of Char;
      CTimeType = Array[1..6] of Char;

        MessageRecord = record
                    Deleted: byte;
                    Number: integer;
                    FromUser: CNameType;
                    ToUser: CNameType;
                    Topic: CNameType;
                    Date: CDateType;
                    DestNet: integer;
                    Time: CTimeType;
                    WeekDay: byte;
                    x1: array [1..2] of byte;
                    DestNode: integer;
                    PermPriv: byte;
                    Received: byte;
                    ReplyNumber: array [1..3] of integer;
                    OrigNumber: integer
                  end;



Procedure SendMessage(AddrTo, Frm, Sub, AName, FName : string; DNe, DNo : Integer);
Function C2P(Source : String) : String;
Procedure P2CName(s : String; var WorkName : CNameType);

Implementation

Function C2P(Source: string): string;  { C strings to Pascal strings }
Begin
  C2P := copy(Source,1,pos(#0,Source)-1)
End;

Function LeadingZeroB (w : Word) : String;
var s : string;
  Begin;
    Str(w:0, s);
    If Length(s) = 1 then
      s := '0' + s;
    LeadingZeroB := s;
  End;

Function LeadingSpaceB (w : Word) : String;
var s : string;
  Begin;
    Str(w:0, s);
    If Length(s) = 1 then
      s := ' ' + s;
    LeadingSpaceB := s;
  End;


Procedure P2CName(s : String; var WorkName : CNameType);
  var Int1 : Integer;
  Begin;
    For Int1 := 1 to Length(s) do
      WorkName[Int1] := s[Int1];
    WorkName[Length(s) + 1] := Chr(0);
  End;

 Procedure P2CDate(s : String; var WorkDate : CDateType);
  var Int1 : Integer;
  Begin;
    For Int1 := 1 to 8 do
      WorkDate[Int1] := s[Int1];
    WorkDate[9] := Chr(0);
  End;

Procedure P2CTime(s : String; var WorkTime : CTimeType);
  var Int1 : Integer;
  Begin;
    For Int1 := 1 to 5 do
      WorkTime[Int1] := s[Int1];
    WorkTime[6] := Chr(0);
  End;

Procedure SendMessage(AddrTo, Frm, Sub, AName, FName : string; DNe, DNo : Integer);
var
  Txt1, Txt2 : Text;
  MessageDate, MessageTime : String[25];
  ThisFile: searchrec;
  EndSeek: longint;
  Messages: file of MessageRecord;
  Buffer: MessageRecord;
  Work: string[9];
  MessagePath : string;
  Hour, Minute, Second, Sec100: Word;
  Year, Month, Day, DOW : Word;
  Hours, Minutes, Years, Days, Months : String[5];
  MesFileNo, MesNo : Integer;
  DirInfo : SearchRec;
  Str1 : String;
  VersionNo : Integer;

begin
  if AName[length(AName)] <> '\' then AName := AName + '\';
  MessagePath := AName + 'message.ctl';
  GetTime( hour, minute, second, sec100 );
  GetDate( year, month, day, DOW );
  Hours := LeadingSpaceB(Hour);
  Minutes := LeadingZeroB(Minute);
  Days := LeadingZeroB(Day);
  Months := LeadingSpaceB(month);
  Years := LeadingZeroB(Year);
  MessageDate := Concat(Months, '-', Days, '-', copy( Years, length(Years)-1, 2));
  MessageTime := Concat(Hours, ':' , Minutes);

  FindFirst(MessagePath, 0, ThisFile);
  If DosError <> 0 then Begin;
    Writeln('Un-initialized Message Area, ', AName);
    Halt(1);
  End;
  EndSeek := ThisFile.Size div 128;
  Assign(Messages, MessagePath);
  Reset(Messages);
  Seek(Messages,EndSeek-1);
  Read(Messages,Buffer);
  Seek(Messages,EndSeek);

  With Buffer do Begin
    Deleted := 0;
    Number := Number + 1;
    str(Number,Work);
    while length(Work) < 5 do Work := '0' + Work;
    P2CName(Frm, FromUser);
    P2CName(AddrTo, ToUser);
    P2CName(Sub, Topic);
    P2CDate(MessageDate, Date);
    P2CTime(MessageTime, Time);
    DestNet := DNe;
    DestNode := DNo;
    WeekDay := DOW + 1;
    PermPriv := 1;
    Received := 0;
    ReplyNumber[1] := 0;
    ReplyNumber[2] := 0;
    ReplyNumber[3] := 0;
    OrigNumber := 0
  end;

  Write(Messages,Buffer);
  Close(Messages);

  FindFirst(Concat(AName, 'GTMSGS\*.MSG'), AnyFile, ThisFile);
  If DosError = 0 then VersionNo := 15 else VersionNo := 16;

  If VersionNo = 15 then Begin;
    Str(Buffer.Number, Work);
    While Length(Work) < 5 do Work := '0'+Work;
    Assign(Txt2, Concat(AName, 'GTMSGS\', Work, '.MSG'));
    ReWrite(Txt2);
  End;

  If VersionNo = 16 then Begin;
    MesFileNo := (Buffer.Number div 10);
    MesNo := Buffer.Number - (10 * MesFileNo);
    MesNo := MesNo - 1;
    MesFileNo := MesFileNo + 1;
    If MesNo < 0 then Begin;
      MesNo := 9;
      MesFileNo := MesFileNo - 1;
    End;
    Str(MesFileNo, Work);
    While Length(Work) < 5 do Work := '0'+Work;
    FindFirst(Concat(AName, 'GTMSGS\', Work, '.MES'), AnyFile, ThisFile);
    Assign(Txt2, Concat(AName, 'GTMSGS\', Work, '.MES'));
    If DOSError <> 0 then Begin;
      ReWrite(Txt2);
    end else Begin;
      Append(Txt2);
    End;
  End;
  FindFirst(FName, AnyFile, DirInfo);
  If DosError <> 0 then Begin;
    Write(Concat('missing file in procedure SendMessage: ', FName));
    Halt(1);
  End;
  Assign (Txt1, FName);
  Reset (Txt1);
  If VersionNo = 16 then
    Writeln(Txt2, ^X'SOM', MesNo);
  While Not EOF(Txt1) do begin;
    Readln(Txt1, Str1);
    Writeln(Txt2, Str1);
  End;
  Close(Txt1);
  Close(Txt2);
End;

Begin;
End.
